<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

/********************************************************/
/* Tronque un texte  la longueur $length et ajoute ... */
/********************************************************/
function cut_text($text, $length=60){
	if (strlen($text) > $length){
		$text = substr($text, 0, $length);
		$last_space = strrpos($text, ' ');
		$text = substr($text, 0, $last_space) . "...";
	}
	return $text;
}

/************************************************/
/* S'occupe de l'affichage des pages d'archives */
/************************************************/
function show_pages($page,$n_page,$param){
	global $MYSELF, $LANG;

	echo "<p align=right>";
	echo "<table class=atk_default cellspacing=0px><tr><td class=atk_title align=right>";
	echo $LANG["PAGES"] . ": ";

	// Partie 0 : << page prcdente
	$k=$page-1;
	if($page>1) echo "&nbsp;<a class=atk_menu href='" . $MYSELF . "page=$k$param'><<</a>";

	// Partie 1: [1-10]
	if($page>10){
		$k=ceil($page/10)*10-20+1;
		$l=$k+9;
		echo "&nbsp;<a class=atk_menu href='" . $MYSELF . "page=$k$param'>";
		echo "[$k-$l]";
		echo "</a>";
	}

	// Partie 2: Chaque page
	$l=ceil($page/10)*10;
	$k=$l-9;
	if($n_page<=$l) $l=$n_page;
	for($j=$k;$j<=$l;$j++){
		if($page==$j){
			echo "&nbsp;<b><span class=atk_selected>";
			echo "$j";
			echo "</span>";
		} else {
			echo "&nbsp;<a class=atk_menu href='" . $MYSELF . "page=$j$param'>";
			echo "$j";
			echo "</a>";
		}
	}

	// Partie 3: [21-30]
	if($n_page>=$j){
		$k=ceil($page/10)*10+1;
		$l=$k+9;
		if($l>$n_page) $l=$n_page;
		echo "&nbsp;<a class=atk_menu href='" . $MYSELF . "page=$k$param'>";
		echo "[$k-$l]";
		echo "</a>";
	}

	// Partie 4 : >> page suivante
	$k=$page+1;
	if($page<$n_page) echo "&nbsp;<a class=atk_menu href='" . $MYSELF . "page=$k$param'>>></a>";

	echo "</td></tr></table>";
}

/********************************************/
/* Vrifie qu'un fichier existe par son url */
/********************************************/
function file_exist($url){
	$temp = error_reporting(E_ALL & ~(E_ERROR | E_WARNING | E_PARSE | E_NOTICE |
E_CORE_ERROR | E_CORE_WARNING | E_COMPILE_ERROR | E_COMPILE_WARNING | E_USER_ERROR |
E_USER_WARNING | E_USER_NOTICE)); 
	// La variable intermdiaire $arr est indispensable pour un hbergement online (???)
	$arr[0]=$url;
	$tmp=$arr[0];
	$file = fopen("$tmp", "r"); 
	if ($file) { 
		fclose($file); 
	} else { 
		error_reporting($temp); 
		return 0; 
	} 
  error_reporting($temp); 
  return 1;
}

/***************************************************/
/* Suppression d'un post et de toutes ses rponses */
/***************************************************/
function delete($post){
	global $ATK_LOGIN;

	$title = "Post id=$post and their answers have been deleted by $ATK_LOGIN";
	reccord_error($title, "");

	// Rcupre les infos du post  supprimer
	$query = "
		SELECT forum,group_id,num,tab,answer,id_poll
		FROM atk_posts
		WHERE id=$post";
	$sql = dbquery($query);
	$t=mysql_fetch_array($sql);
	$group=$t["group_id"];
	$num=$t["num"];
	$tab=$t["tab"];
	$forum=$t["forum"];
	$answer=$t["answer"];
	$id_poll=$t["id_poll"];
	
	// Suppression d'un sondage associ
	if(!empty($id_poll)){
		$query = "DELETE FROM atk_polls WHERE id_poll=\"$id_poll\"";
		dbquery($query);
		$query = "DELETE FROM atk_votes WHERE id_poll=\"$id_poll\"";
		dbquery($query);
	}

	// Rcupre le suivant de $num  son niveau dans $next_num
	$query = "
		SELECT num
		FROM atk_posts
		WHERE group_id=\"$group\" AND num>\"$num\" AND tab<=\"$tab\"
		ORDER BY num ASC
		LIMIT 1";
	$sql = dbquery($query);
	// S'il existe au moins 1 enregistrement
	if($t=mysql_fetch_row($sql)){
		// Supprime le bloc qui correspond au post et ses rponses
		$next_num=$t[0];
		
		// On dcompte le nombre de post de chaque auteur
		$query = "
			SELECT sender FROM atk_posts
			WHERE group_id=$group
			AND num>=\"$num\" AND num<\"$next_num\"";
		$sql = dbquery($query);
		while($row=mysql_fetch_array($sql)){
			$sender = $row["sender"];
			if($sender != "nobody"){
				$query = "
					UPDATE atk_users
					SET nb_post = nb_post-1
					WHERE login = \"$sender\"";
				dbquery($query);	
			}
		}		

		$query = "
			DELETE FROM atk_posts
			WHERE group_id=\"$group\"
			AND num>=\"$num\" AND num<\"$next_num\"";
		dbquery($query);
		// Nombre de message supprim
		$diff=$next_num-$num;
		// On remet les num suivant  jour, fonctionne mme si intgrit endommag
		$query = "
			UPDATE atk_posts
			SET num=num-$diff
			WHERE group_id=\"$group\"
			AND num>=\"$next_num\"";
		dbquery($query);
	// Sinon on supprime le dernier post et ses rponses
	} else {

		// On dcompte le nombre de post de chaque auteur
		$query = "
			SELECT sender FROM atk_posts
			WHERE group_id=\"$group\"
			AND num>=\"$num\"";
		$sql = dbquery($query);
		while($row=mysql_fetch_array($sql)){
			$sender = $row["sender"];
			if($sender != "nobody"){
				$query = "
					UPDATE atk_users
					SET nb_post = nb_post-1
					WHERE login = \"$sender\"";
				dbquery($query);	
			}
		}
		
		// Nombre de message supprim
		$query = "
			SELECT count(*)
			FROM atk_posts
			WHERE group_id=$group
			AND num>=\"$num\"";
		$diff = dbgetfirst($query);
		// Supprime les messages
		$query = "
			DELETE FROM atk_posts
			WHERE group_id=$group
			AND num>=\"$num\"";
		dbquery($query);
	}
	
	// On update le nombre de rponse du answer dont on a supprim un post
	$query = "
		UPDATE atk_posts
		SET nb_direct_answer = nb_direct_answer - 1
		WHERE id = $answer";
	dbquery($query);

	// On update les infos dans le sujet si il existe encore
	if($post != $group){

		// On cherche le nombre de rponses du sujet
		$query = "SELECT count(id) FROM atk_posts WHERE group_id=$group";
		$nb = dbgetfirst($query);
		$nb--;
	
		// On rcupre l'id de la dernire rponse
		$query = "
			SELECT max(id)
			FROM atk_posts
			WHERE group_id=$group";
		$last_id = dbgetfirst($query);
		
		// Rcupre le dernier sender du sujet et sa date
		$query = "
			SELECT sender, date
			FROM atk_posts
			WHERE id=$last_id";
		$row = dbgetline($query);
		$last_sender = $row["sender"];
		$last_date = $row["date"];	

		// On update les infos dans le sujet
		$query = "
			UPDATE atk_posts
			SET last_id=$last_id, last_sender='$last_sender', last_date=$last_date, nb_answer=$nb
			WHERE group_id = $group";
		dbquery($query);

	}
	
	$query = "SELECT max(id) FROM atk_posts WHERE forum=$forum";
	$last_id = dbgetfirst($query);
	
	if($last_id){
		$query = "SELECT sender, date FROM atk_posts WHERE id=$last_id";
		$row=dbgetline($query);
		$last_sender = $row["sender"];
		$last_date = $row["date"];
	} else {
		$last_sender="";
		$last_date=0;
		$last_id=0;
	}
	
	// On update le nombre de message du forum
	$query = "
		UPDATE atk_forums
		SET
		nb_post = nb_post - $diff, last_id=$last_id,
		last_sender='$last_sender', last_date=$last_date
		WHERE id = $forum";
	dbquery($query);

}

/***********************************/
/* Initialise le comptage du temps */
/***********************************/
function get_microtime(){   
	list($tps_usec, $tps_sec) = explode(" ",microtime());   
	return ((float)$tps_usec + (float)$tps_sec);   
}

/**********************************/
/* Vrifie si un user existe dj */
/**********************************/
function user_exist($login){
	$query = "SELECT COUNT(*) FROM atk_users WHERE login='$login'";
	$n = dbgetfirst($query);
	return $n;
}

/*************************************************************/
/* Envoie les headers pour ne pas garder les page en mmoire */
/*************************************************************/
function no_cache(){
	// Permet la ractualisation de la page  chaque affichage
	@header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
	@header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
	@header("Cache-Control: no-cache, must-revalidate");
	@header("Pragma: no-cache");
}

/******************************************************************/
/* Envoie les premiers tags HTML au navigateur avec les meta-tags */
/******************************************************************/
function meta_tags(){
	global $PF;

	if(empty($PF["meta_title"])) $PF["meta_title"]=$PF["title"];
	if(empty($PF["meta_description"])) $PF["meta_description"]=$PF["title"];
	if(empty($PF["meta_keywords"])) $PF["meta_keywords"]=str_replace(" ",",",$PF["title"]);
	
	?>
		<TITLE><? echo $PF["meta_title"]; ?></TITLE>
		<META HTTP-EQUIV= "Content-Type" CONTENT="text/html; charset=ISO-8859-15">
		<meta name="Description" content="<? echo $PF["meta_description"]; ?>">
		<meta name="Keywords" content="<? echo $PF["meta_keywords"]; ?>">
		<meta name="Revisit-after" content="14 days">
		<meta name="Robots" content="all">
		<link rel="SHORTCUT ICON" href="./images/favicon.ico">
	<?
}

/***************************************************/
/* Supprime l'image de l'avatar $path si il existe */
/***************************************************/
function delete_avatar($path){
	$file = basename($path);
	if($path == "./avatar/$file" && file_exists("./avatar/$file"))
		unlink("./avatar/$file");
}
?>
