<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

/***********************/
/* Connexion  l'index */
/***********************/
function login($login, $passwd, $cookie){
	global $SALT, $LANG, $COOKIE_EXPIRE, $ATK_LOGIN, $ATK_PASSWD, $DROIT, $URL_BAN, $DATE, $owner;
	global $PHP_SESS_ENABLED;

	// On crypte le password donn pour faire une comparaison
	$passwd=crypt($passwd,$SALT);
	// Recherche si le login/password existe dans la table users
	$query="SELECT login,passwd,admin,ban FROM atk_users WHERE login='$login' AND passwd='$passwd'";
	$sql=dbquery($query);
	// Si il existe et password correcte alors
	if($row=mysql_fetch_array($sql)){
		
		// Gestion des bannissements
		if($row["ban"]>$DATE){
			setcookie("ATK_BAN", "1", $row["ban"]);
			header("location:$URL_BAN");
			exit;
		}

		if($PHP_SESS_ENABLED){
		
			// Le $ATK_LOGIN devient le $login
			$ATK_LOGIN=$row["login"];
			$ATK_PASSWD=$row["passwd"];
			$_SESSION["SESS_LOGIN"] = $ATK_LOGIN;
			$_SESSION["SESS_PASSWD"] = $ATK_PASSWD;
			
			// $droit=1 au moins (0:Invit(e), 1:membres, 2:Admin)
			$DROIT=1;
			// Vrifie si le $ATK_LOGIN est l'administrateur
			$PRIV=strrev(decbin($row["admin"]));
			if(!empty($PRIV[4]) OR $ATK_LOGIN==$owner) $DROIT=2;
			
			// Initialise le message de confirmation  afficher
			$message=$LANG["LOGIN-OK"];
	
			// Si reconnaissance auto coch, envoie les cookies
			if(!empty($cookie) && $cookie=="on"){
				setcookie("COOKIE_L",$ATK_LOGIN,$COOKIE_EXPIRE);
				setcookie("COOKIE_P",$ATK_PASSWD,$COOKIE_EXPIRE);
			}
			
		} else {
			
			// Le $ATK_LOGIN devient le $login
			$ATK_LOGIN=$row["login"]; // Rcupre le login avec la bonne casse
			$ATK_PASSWD=$row["passwd"];
			// $droit=1 au moins (0:Invit(e), 1:membres, 2:Admin)
			$DROIT=1;
			// Vrifie si le $ATK_LOGIN est l'administrateur
			$PRIV=strrev(decbin($row["admin"]));
			if(!empty($PRIV[4])) $DROIT=2;
			// Initialise le message de confirmation  afficher
			$message=$LANG["LOGIN-OK"];
			// Si reconnaissance auto coch, envoie les cookies
			// d'identification automatique
			if(empty($cookie)) $cookie=0;
			if($cookie=="on"){
				setcookie("ATK_LOGIN",$ATK_LOGIN,$COOKIE_EXPIRE);
				setcookie("ATK_PASSWD",$ATK_PASSWD,$COOKIE_EXPIRE);
			} else {
				setcookie("ATK_LOGIN",$ATK_LOGIN);
				setcookie("ATK_PASSWD",$ATK_PASSWD);
			}
			
		}


	} else {
		// Erreur login/mot de passe
		$message=$LANG["LOGIN-ERROR"];
	}
	
	return $message;	
}

/**************************/
/* Dconnexion de l'index */
/**************************/
function disconnect(){
	global $LANG, $PF, $ATK_LOGIN, $ATK_PASSWD, $owner, $REMOTE_ADDR;
	global $PHP_SESS_ENABLED;

	// Session php
	if($PHP_SESS_ENABLED){
	
		// Dconnexion de tous les forums
		$_SESSION['SESS_LOGIN']="nobody";
		$_SESSION['SESS_PASSWD']="";
		// Supprime tous les cookies
		setcookie("COOKIE_L");
		setcookie("COOKIE_P");
	
		$FAST_VIEW = 0;
		if($PF["fast_view"]==1) $FAST_VIEW=1;
		$DROIT=0;
	
		// Met  jour l'invit dans la table de session
		$query = "
			UPDATE atk_sessions
			SET user = 'nobody', droit=$DROIT, fast_view=$FAST_VIEW
			WHERE user = '$ATK_LOGIN'";
		dbquery($query);
	
		// Rinitialisation du login
		$ATK_LOGIN = "nobody";
		$ATK_PASSWD = "";
		
	// Session fait "maison"
	} else {

		setcookie("ATK_SESS");
		$query = "
			DELETE FROM atk_sessions
			WHERE user='$ATK_LOGIN' OR (ip='$REMOTE_ADDR' AND user='$LANG[NOBODY]')";
		dbquery($query);

		setcookie("ATK_LOGIN", "nobody");
		setcookie("ATK_PASSWD");
		$ATK_LOGIN = "nobody";
		$ATK_PASSWD = "";
		
	}

	return $LANG["ALERT-DISCONNECT"];
}

/*************************/
/* Inscription  l'index */
/*************************/
function subscribe($owner,$login,$passwd,$passwd2,$email,$show_email,$cookie){
	global $PF, $ATK_LOGIN, $ATK_PASSWD, $SALT, $DATE;
	global $LANG, $LAST_VISIT_DEFAULT, $COOKIE_EXPIRE, $choix;
	global $PHP_SESS_ENABLED;

	$message="";
	// Vrification de la validit des renseignements fournis
	if($passwd!=$passwd2)
		$message=$LANG["SUBSCRIBE-PASSWD-ERROR"];
	if(strlen($passwd)<4)
		$message=$LANG["SUBSCRIBE-PASSWD-ERROR-2"];
	if(strlen($passwd)>30)
		$message=$LANG["SUBSCRIBE-PASSWD-ERROR"];
	if(!$PF["infos_perso"] && !(eregi("^[_\.0-9a-z-]+@([0-9a-z-]+\.)+[a-z]{2,4}$",$email)))
		$message=$LANG["SUBSCRIBE-EMAIL-ERROR"];
	if(strlen($login)<2)
		$message=$LANG["SUBSCRIBE-LOGIN-ERROR"];
	if(strlen($login)>30)
		$message=$LANG["SUBSCRIBE-LOGIN-ERROR"];
	if(ereg("[[:punct:]]", $login) || !ereg("[[:alnum:]]", $login))
		$message = $LANG["SUBSCRIBE-LOGIN-ERROR-3"];
	if(!$message && (user_exist($login) || $login=="nobody"))
		$message=$LANG["SUBSCRIBE-LOGIN-ERROR-2"];
	
	// Si tout est OK (pas de message d'erreur)
	if(!$message){

		// Cryptage du mot de passe
		$passwd=crypt($passwd,$SALT);

		if($PHP_SESS_ENABLED){
			
			// Dernire visite par dfaut
			$ATK_LOGIN = $login;
			$ATK_PASSWD = $passwd;
			if($show_email=="on") $show_email=0; else $show_email=1;
	
			// On enregistre le nouveau user dans la table users
			$query = "
				INSERT INTO atk_users
				(login,owner,passwd,email,show_email,alert_mp,subscribe,signature,other)
				VALUES ('$ATK_LOGIN','$owner','$ATK_PASSWD','$email','$show_email','1','$DATE','','')";
			$sql = dbquery($query);
			
			// Enregistrement du login dans la session
			$_SESSION['SESS_LOGIN'] = $ATK_LOGIN;
			$_SESSION['SESS_PASSWD'] = $ATK_PASSWD;
	
			// Cre les cookies si reconnaissance automatique coche
			if($cookie=="on"){
				setcookie("COOKIE_L",$ATK_LOGIN,$COOKIE_EXPIRE);
				setcookie("COOKIE_P",$ATK_PASSWD,$COOKIE_EXPIRE);
			}
			
		} else {
			
			// Dernire visite par dfaut
			$LAST_VISIT=$LAST_VISIT_DEFAULT;
			$ATK_LOGIN=$login;
			$ATK_PASSWD=$passwd;
			if($show_email=="on") $show_email=0;
			else $show_email=1;
			// On enregistre le nouveau user dans la table users
			$query = "
				INSERT INTO atk_users
				(login,owner,passwd,email,show_email,alert_mp,subscribe,signature,other)
				VALUES ('$ATK_LOGIN','$owner','$ATK_PASSWD','$email','$show_email','1','$DATE','','')";
			$sql = dbquery($query);
			// Cre les cookies si reconnaissance automatique coche
			if($cookie=="on"){
				setcookie("ATK_LOGIN",$ATK_LOGIN,$COOKIE_EXPIRE);
				setcookie("ATK_PASSWD",$ATK_PASSWD,$COOKIE_EXPIRE);
			} else {
				setcookie("ATK_LOGIN",$ATK_LOGIN);
				setcookie("ATK_PASSWD",$ATK_PASSWD);
			}
			
		}

		$message=$LANG["SUBSCRIBE-OK"];

	} else {
		// Si message d'erreur, raffiche le formulaire
		$choix=2;
		// Fonctions pour rafficher le form d'inscription
		include("./index/subscribe.php");
	}

	return $message;
}

/**************************/
/* Dplace les catgories */
/**************************/
function move_cat($id_cat, $dir){
	global $DROIT, $owner;
	
	if($DROIT!=2) error(43);
	
	$query = "SELECT order_cat FROM atk_category WHERE id=$id_cat";
	$order_cat = dbgetfirst($query);
	
	// Vrifie qu'on ne sort pas des limites
	if($dir=="up"){
		if($order_cat==0) return 0;	
	} else {
		$query = "SELECT MAX(order_cat) FROM atk_category WHERE owner='$owner'";
		$max_order = dbgetfirst($query);
		if($order_cat>=$max_order) return 0;		
	}	
	
	if($dir=="up") $new_order=$order_cat-1;
	else $new_order=$order_cat+1;
	
	$query="UPDATE atk_category SET order_cat=$order_cat WHERE order_cat=$new_order AND owner='$owner'";
	dbquery($query);	
	
	$query="UPDATE atk_category SET order_cat=$new_order WHERE id=$id_cat AND owner='$owner'";
	dbquery($query);
		
}

/**********************/
/* Dplace les forums */
/**********************/
function move_forum($id_forum, $dir){
	global $DROIT, $owner;
	
	if($DROIT!=2) error(44);
	
	$query = "SELECT category, order_cat FROM atk_forums WHERE id=$id_forum";
	$row = dbgetline($query);
	$id_cat = $row["category"];
	$order_cat = $row["order_cat"];
	
	// Vrifie qu'on ne sort pas des limites
	if($dir=="up"){
		if($order_cat==0) return 0;	
	} else {
		$query = "SELECT MAX(order_cat) FROM atk_forums WHERE category=$id_cat";
		$max_order = dbgetfirst($query);
		if($order_cat>=$max_order) return 0;		
	}	
	
	if($dir=="up") $new_order=$order_cat-1;
	else $new_order=$order_cat+1;
	
	$query="UPDATE atk_forums SET order_cat=$order_cat WHERE order_cat=$new_order AND category=$id_cat AND owner='$owner'";
	dbquery($query);	
	
	$query="UPDATE atk_forums SET order_cat=$new_order WHERE id=$id_forum AND category=$id_cat AND owner='$owner'";
	dbquery($query);

}
?>
