<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

/*********************/
/* Modifie le profil */
/*********************/
function profile($email, $show_email, $alert_mp, $avatar, $town, $text, $url, $smiley, $msn, $aim, $skype, $yahoo, $icq, $other, $fast_view){
	global $ATK_LOGIN, $ATK_PASSWD, $LANG, $choix, $FAST_VIEW, $PF, $ID_SESS, $_FILES, $MAX_FILESIZE;

	// Vrifie la validit de l'adresse email
	if(!$PF["infos_perso"] && !(eregi("^[_\.0-9a-z-]+@([0-9a-z-]+\.)+[a-z]{2,4}$",$email)))
		$message=$LANG["PROFILE-EMAIL-ERROR"];

	// Adresse de l'ancien avatar
	$query = "SELECT avatar FROM atk_users WHERE login='$ATK_LOGIN'";
	$old_avatar = dbgetfirst($query);
		
	// UPLOAD de l'avatar
	if(empty($message) && !empty($_FILES['upload']['name'])){
	
		if( preg_match('#[\x00-\x1F\x7F-\x9F/\\\\]#', $_FILES['upload']['name']) )
		{
    			exit("Nom de fichier non valide");
		}
		
		$file = $_FILES['upload']['tmp_name'];
		if(file_exists($file)){
		
			$size = getimagesize($file);
			if(empty($size)) exit("Fichier incorrect");
			
			// on vrifie maintenant l'extension
		    $type_file = $_FILES['upload']['type'];
		    if(strstr($type_file, 'jpg')) $type="jpg";
		    if(strstr($type_file, 'jpeg')) $type="jpeg";
		    if(strstr($type_file, 'bmp')) $type="bmp";
		    if(strstr($type_file, 'gif')) $type="gif";
		    if(strstr($type_file, 'png')) $type="png";
		    if(empty($type)) $message=$LANG["PROFILE-AVATAR-ERROR-1"];
	
			$filesize=filesize($file)/1024;
			if($filesize>$MAX_FILESIZE) $message=$LANG["PROFILE-AVATAR-ERROR-2"];
		    		
		    // on copie le fichier dans le dossier de destination
		    if (empty($message)){

			    // Prpare un nom de fichier unique
			    $replace = array("" => "Y", "" => "u", "" => "A", "" => "A",
                "" => "A", "" => "A", "" => "A", "" => "A",
                "" => "A", "" => "C", "" => "E", "" => "E",
                "" => "E", "" => "E", "" => "I", "" => "I",
                "" => "I", "" => "I", "" => "D", "" => "N",
                "" => "O", "" => "O", "" => "O", "" => "O",
                "" => "O", "" => "O", "" => "U", "" => "U",
                "" => "U", "" => "U", "" => "Y", "" => "s",
                "" => "a", "" => "a", "" => "a", "" => "a",
                "" => "a", "" => "a", "" => "a", "" => "c",
                "" => "e", "" => "e", "" => "e", "" => "e",
                "" => "i", "" => "i", "" => "i", "" => "i",
                "" => "o", "" => "n", "" => "o", "" => "o",
                "" => "o", "" => "o", "" => "o", "" => "o",
                "" => "u", "" => "u", "" => "u", "" => "u",
                "" => "y", "" => "y", " " => "_", "@" => "a");
				$file_login  = strtr($ATK_LOGIN, $replace);
				$tmp_filename = $file_login;
				$i = 1;
				while(file_exists($tmp_filename)){
					$tmp_filename = $file_login . "_" . $i;
					$i++;					
				}
				$file_login = $tmp_filename;
			    
			    $path_file = "./avatar/" . $file_login . "." . $type;
			    			    
			    delete_avatar($old_avatar);
			   	
			    if(@copy($file,$path_file)) $avatar=$path_file;
				else $message=$LANG["PROFILE-AVATAR-ERROR-3"];
				
			}
		}
	} else {
		// Vrifie l'url de l'avatar
		if($avatar=="http://") $avatar="";
		if($old_avatar != $avatar) delete_avatar($old_avatar);
	}

	if(empty($message)){

		// Traitement de la signature
		$text=before_reccord($text);
		
		if(!empty($other)){
			foreach($other AS $key=>$value){
				$other[$key] = str_replace("\"","'",$other[$key]);
				$other[$key] = before_reccord($other[$key]);
			}
		}
		$other_all = addslashes(serialize($other));
		
		// Validit de l'image + dimension
		$size[0]=100; $size[1]=100;
		if(file_exist($avatar)){
			$size=getimagesize($avatar);
			if($size[0]>=$size[1] AND $size[0]>120){
					$size[1]=$size[1]*120/$size[0];
					$size[0]=120;
			}
			if($size[1]>$size[0] AND $size[1]>120){
					$size[0]=$size[0]*120/$size[1];
					$size[1]=120;
			}
			if($size[0]==0 OR $size[1]==0){
				$size[0]=100; $size[1]=100;
			}
		}
		if($url=="http://") $url="";
		
		$url = str_replace("\"","'",$url);
		$town = str_replace("\"","'",$town);
		$avatar = str_replace("\"","'",$avatar);
		$msn = str_replace("\"","'",$msn);
		$icq = str_replace("\"","'",$icq);
		$aim = str_replace("\"","'",$aim);
		$skype = str_replace("\"","'",$skype);
		$yahoo = str_replace("\"","'",$yahoo);
		
		// Autorisation de divulguer l'email
		if($show_email!='on') $show_email=0; else $show_email=1;

		// Mise  jour dans la bdd
		$query = "
			UPDATE atk_users
			SET email=\"$email\",town=\"$town\",
			show_email=\"$show_email\",alert_mp=\"$alert_mp\",url=\"$url\",
			avatar=\"$avatar\",size_0=\"$size[0]\",
			size_1=\"$size[1]\",signature=\"$text\",smiley=\"$smiley\",
			msn=\"$msn\",aim=\"$aim\",skype=\"$skype\",yahoo=\"$yahoo\",icq=\"$icq\",
			other=\"$other_all\",fast_view=\"$fast_view\"
			WHERE login=\"$ATK_LOGIN\" AND passwd=\"$ATK_PASSWD\"";
		dbquery($query);
		
		// Si on est sur un forum, on met  jou le $FAST_VIEW courant dans la session
		if(!empty($PF["fast_view"]) AND !empty($ID_SESS) AND $PF["fast_view"]==2){
			$FAST_VIEW=$fast_view;
			$query = "
				UPDATE atk_sessions
				SET fast_view='$fast_view'
				WHERE id='$ID_SESS'";
			dbquery($query);
		}
		// Message de la mise  jour
		$message=$LANG["PROFILE-OK"];
		// Retour  la 1re page du forum
		$choix=0;
	// Raffiche le formulaire
	} else {
		// On inclu la fonction qui affiche le profil
		include("./index/profile.php");
		$choix=3;
	}

	return $message;
}

/*********************************************/
/* Enregistre un message dans une messagerie */
/*********************************************/
function inbox_send($recipient,$title,$text){
	global $DATE, $LANG, $ATK_LOGIN, $option, $DELAY_MSG_ALREADY_SENT, $PF;

	// Vrification des champs renvoys
	if($text=="" OR $recipient=="") $message=$LANG["INBOX-ERROR-SEND"];

	// Si pas d'erreur dans les messages...
	if(empty($message)){

		if(empty($title)) $title=$LANG["NO-OBJECT"];
		if(!ereg("[[:alnum:]]", $title)) $title=$LANG["NO-OBJECT"];
		
		// Traitement du titre et du texte
		$text=before_reccord($text);
		$title=before_reccord($title);
		
		// recherche les destinataires
		$recipient_array = preg_split ("[( )*,( )*] ", $recipient);
		$j=0;
	
		// Envoie le message  chaque destinataire
		for($i=0; $i<count($recipient_array); $i++){
	
	     	// Rcupre le destinataire courant
			$recipient = $recipient_array[$i];
			
			// Vrifications de l'existence du destinataire
			$query="SELECT alert_mp FROM atk_users WHERE login='$recipient'";
			$sql = dbquery($query);
			if($row = mysql_fetch_array($sql)){
				
				// Stocke l'alerte par email ou non
				$alert_mp = $row["alert_mp"];
	
				// Vrifie que le message n'a pas encore t envoy
				// (en cas de double click par exemple)
				$limit=$DATE-$DELAY_MSG_ALREADY_SENT;
				$query = "
					SELECT COUNT(*)
					FROM atk_inbox
					WHERE sender='$ATK_LOGIN'
					AND date > $limit
					AND title='$title'
					AND text='$text'
					AND recipient = '$recipient'";
				$nb = dbgetfirst($query);
				if(!$nb){

					$query = "
						INSERT INTO atk_inbox (sender,recipient,title,text,date,seen)
						VALUES ('$ATK_LOGIN','$recipient','$title','$text',$DATE,0)";
					dbquery($query);
		
					// Envoie un email d'alerte au destinataire
					if($PF["mail_actived"] AND $alert_mp) mp_mail($recipient);
		
				// Message dj ajout
				} else $not_send[$j++]=$recipient;

			} else $not_send[$j++]=$recipient;
	
		}
	
	}
	
	if(empty($message) && !empty($not_send) && count($not_send)==count($recipient_array)) $message = $LANG["INBOX-NO-SEND"];
	if(empty($message) && !empty($not_send) && count($not_send)<count($recipient_array)){
		$list = implode($not_send, ", ");
		$LANG["INBOX-PARTIAL-SEND"]=str_replace("%list",$list,$LANG["INBOX-PARTIAL-SEND"]);
		$message = $LANG["INBOX-PARTIAL-SEND"];
	}
	if(empty($message)) $message = $LANG["INBOX-TOTAL-SEND"];
	else $option = "write";

	return $message;
}

/**************************************/
/* Vide la corbeille de la messagerie */
/**************************************/
function inbox_purge(){
	global $ATK_LOGIN, $LANG;

	$query="
		UPDATE atk_inbox
		SET deleted_done = deleted_done + 1
		WHERE (deleted = 1 OR deleted = 3) AND recipient = '$ATK_LOGIN' AND deleted_done <> 1 AND deleted_done <> 3";
	dbquery($query);
		
	$query="
		UPDATE atk_inbox
		SET deleted_done = deleted_done + 2
		WHERE (deleted = 2 OR deleted = 3) AND sender = '$ATK_LOGIN' AND deleted_done <> 2 AND deleted_done <> 3";
	dbquery($query);
	
	$query="DELETE FROM atk_inbox WHERE deleted = 3 AND deleted_done = 3";
	dbquery($query);

	return $LANG["INBOX-PURGE-OK"];
}

/***************************************************/
/* Restaure/Supprime les messages de la messagerie */
/***************************************************/
function inbox_del($select){
	global $ATK_LOGIN, $LANG;

	for($i=0;$i<count($select);$i++){
		
		$query = "SELECT recipient, sender, deleted FROM atk_inbox WHERE id='" . $select[$i] . "'";
		$row = dbgetline($query);
		
		$deleted = strrev(decbin($row["deleted"]));
		if(strtolower($row["recipient"]) == strtolower($ATK_LOGIN)) $deleted[0] = abs($deleted[0]-1);
		if(strtolower($row["sender"]) == strtolower($ATK_LOGIN)) $deleted[1] = abs($deleted[1]-1);
		$deleted = bindec(strrev($deleted));

		$query="
			UPDATE atk_inbox
			SET deleted = '$deleted'
			WHERE id='" . $select[$i] . "'";
		dbquery($query);

	}
}

/*********************************/
/* Gnre un nouveau password et */
/* envoie un email               */
/*********************************/
function random_passwd($login){
	global $LANG, $SALT, $DROIT;

	// Vrifie que c'est un invit
	if($DROIT>0) error(7);

	// Vrifie le login et rcupre l'email
	$query = "
		SELECT atk_users.login,atk_users.email
		FROM atk_users WHERE login='$login'";
	$sql = dbquery($query);
	if($row=mysql_fetch_array($sql)){
		// Gnrateur de mots de passe
		$char_v = "aeiouy";
		$char_c = "bcdfghjklmnpqrstvwxz";
		$nb_car = 8; // Nombre de lettres du mot de passe
		srand((double)microtime()*1000000);
		for($i=0; $i<$nb_car; $i++)
			if($i&1) $passwd .= $char_v[rand()%strlen($char_v)];
			else $passwd .= $char_c[rand()%strlen($char_c)];
		$passwd = Ucfirst($passwd);
		$password = crypt($passwd,$SALT);
		// Enregistrement du nouveau mot de passe
		$query = "
			UPDATE atk_users
			SET passwd='$password'
			WHERE login='$login'";
		$sql = dbquery($query);
		// Prparation de l'email
		$subject=$LANG["NEWPASSWD-MAIL-SUBJECT"];
		$body=$LANG["NEWPASSWD-MAIL-BODY"];
		$body=str_replace("%user",$row["login"],$body);
		$body=str_replace("%passwd",$passwd,$body);
		send_mail($row["email"],$subject,$body);
		// Message d'avertissement
		$message=str_replace("%email",$row["email"],$LANG["NEWPASSWD-OK"]);
	} else $message=$LANG["NEWPASSWD-FAIL"];

	return $message;
}

/************************************/
/* Modifie le password dans la base */
/************************************/
function modify_passwd($new_passwd_1,$new_passwd_2,$old_passwd){
	global $LANG, $COOKIE_EXPIRE, $SALT, $DROIT, $ATK_LOGIN;

	// Vrifie si ce n'est pas un Invit
	if($DROIT==0) error(7);

	// Rcupre et crypte l'ancien password
	$old_passwd=crypt($old_passwd,$SALT);

	// Vrifie la validit  de l'ancien password
	$query = "
		SELECT count(*)
		FROM atk_users
		WHERE login='$ATK_LOGIN'
		AND passwd='$old_passwd'";
	$sql = dbquery($query);
	$row = mysql_fetch_row($sql);

	// Effectue le changement de mot de passe
	if($new_passwd_1==$new_passwd_2 AND strlen($new_passwd_1)>3 AND $row[0]){
		$passwd=crypt($new_passwd_1,$SALT);
		$query = "
			UPDATE atk_users
			SET passwd='$passwd'
			WHERE login='$ATK_LOGIN'
			AND passwd='$old_passwd'";
		$sql = dbquery($query);
		setcookie("ATK_PASSWD",$passwd,$COOKIE_EXPIRE);
		$message=$LANG["PASSWD-SUCCES"];
	} else $message=$LANG["PASSWD-FAIL"];

	return $message;
}
?>
