<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

// Si l'installation n'a pas encore eu lieu:
// Envoi la console d'installation
if(!file_exists("./common/bddconf.php")){
	include("./install.php");
	exit;
}

/*********************************************************/
/* Initialise les variables et les fonctions ncessaires */
/*********************************************************/
// Fonctions gnrales
include("./common/errors.php");				// Gestion des erreurs
include("./common/config.php");				// Variables de configuration
include("./index/functions.php");				// Fonctions spcifiques
include("./index/common_functions.php");		// Fonctions spcifiques
include("./common/global_func.php");			// Fonctions communes
$tps_start = get_microtime();					// Lance le calcul du temps

dbconnect();								// Connexion  la bdd
include("./index/load.php");					// Chargement des paramtres
include("./lang/" . $PF["language"] . "/" . $PF["language"] . ".php");	// Chargement de la Langue
include("./index/sessions.php");				// Chargement infos visiteurs

// Initialise les variables non initialises
if(empty($msg)) $msg="";
if(empty($page)) $page=0;
if(empty($choix)) $choix=0;
if(empty($action)) $action="";
if(empty($message)) $message="";
if(empty($answer)) $answer=0;
if(empty($title)) $title="";
if(empty($text)) $text="";
if(empty($login)) $login="";

// include ncessaire en fonction des paramtres
include("./common/check_text.php");
if($action) include("./index/actions.php");
if($action) include("./index/common_actions.php");
if($choix==0) include("./index/view_index.php");
if($choix==0 && !empty($PF["show_stat"])) include("./index/infos.php");
if($choix==1) include("./index/login.php");
if($choix==2) include("./index/subscribe.php");
if($choix==3) include("./index/profile.php");
if($choix==5) include("./index/members.php");
if($choix==8) include("./index/passwd.php");
if($choix==9) include("./index/passwd.php");
if($choix==10) include("./index/search.php");
if($choix==11) include("./index/inbox.php");
if($choix==12) include("./index/new_post.php");
if($choix==13) include("./index/infos.php");
?>
