<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

/****************************************/
/* Affiche l'index des forums de $owner */
/****************************************/
function view_index($owner){
	global $PF, $LANG, $BY_ID, $MYSELF, $ATK_VISIT, $LAST_VISIT_DEFAULT, $DROIT, $CONNECTED_INDEX_USER;

	/*************************************/
	/* Effectue les requtes ncessaires */
	/*************************************/
	// Rcupre toutes les rubriques
	$query = "
		SELECT COUNT(atk_forums.id), atk_category.*
		FROM atk_category
		LEFT OUTER JOIN atk_forums
		ON atk_forums.category = atk_category.id
		WHERE atk_category.owner='$owner'
		AND atk_forums.hidden = 0
		GROUP BY atk_category.id
		ORDER BY atk_category.order_cat ASC";
	$sql_cat = dbquery($query);
	
	$num_cat = mysql_num_rows($sql_cat);

	// Recherche les forums de la rubrique
	$query = "
		SELECT atk_forums.nb_post, atk_forums.structure, atk_forums.id, atk_forums.locked, atk_forums.title,
		atk_forums.subject, atk_forums.date, atk_forums.nb_visit,
		atk_forums.filename, atk_forums.passwd, atk_forums.log_login, atk_forums.category ,
		atk_forums.last_id, atk_forums.last_sender, atk_forums.last_date
		FROM atk_category, atk_forums
		WHERE atk_category.id = atk_forums.category
		AND atk_category.owner = '$owner'
		AND atk_forums.hidden = 0
		GROUP BY atk_forums.id
		ORDER BY atk_category.order_cat ASC, atk_forums.order_cat ASC";
	$sql_forum = dbquery($query);		

     if($PF["bg_highlight"] || $PF["bg_onclick"]){
		include("./javascript/highlight.js");
		$highlight = "onClick=\"setRowColor(this, '" . $PF["bg_onclick"] . "', 'click')\" onMouseOver=\"setRowColor(this, '" . $PF["bg_highlight"] . "', 'over')\" onMouseOut=\"setRowColor(this, '', 'out')\"";
	} else $highlight="";
	
	$count=0; $count_cat=0;

	/*********************************************/
	/* Affichage des tableaux de chaque category */
	/*********************************************/
	while($row=mysql_fetch_array($sql_cat)){

		$count_cat++;
		
		// Saut de ligne
		echo "<BR>";

		// Affichage de la rubrique
		echo "<TABLE class=atk_default width=100% cellspacing=0 cellpadding=0>";
		echo "<TR><TD class=atk_title colspan=5>";

			// Affichage de l'entete de la rubrique courante
			echo "<TABLE width=100% cellspacing=0 cellpadding=0><TR>";
			echo "<TD class=atk_body width=22px>";
				echo "<img src='./images/fleche.gif'>";
			echo "</TD><TD>";
				echo "<p class=atk_menu>" . $row["title"];
				
				// On gre le dplacement des rubriques
				if($DROIT==2 && $num_cat>1){
					echo "&nbsp;&nbsp;&nbsp;&nbsp;";
					// On descent la rubrique
					if($count_cat<$num_cat){
						echo "<A href='" . $MYSELF . "action=move_cat&dir=down&id_cat=" . $row["id"] . "'>";
						echo "<IMG src='images/down.gif' border=0>";
						echo "</A>";	
					}
					echo "&nbsp;&nbsp;";
					// On monte la rubrique
					if($count_cat>1){
						echo "<A href='" . $MYSELF . "action=move_cat&dir=up&id_cat=" . $row["id"] . "'>";
						echo "<IMG src='images/up.gif' border=0>";
						echo "</A>";
					}					
				}
				
			echo "</TD>";
			echo "<TD class=atk_body width=50px align=right>";
				echo "<p class=atk_menu>Posts";
			echo "</TD>";
			echo "<TD class=atk_body width=50px align=right>";
	          	echo "<p class=atk_menu>" . $LANG["INDEX-VISITS"];
			echo "</TD>";
			echo "<TD class=atk_body align=center width=130px>";
	          	echo "<p class=atk_menu>" . $LANG["INDEX-LAST-POST"];
			echo "</TD>";
			echo "</TR></TABLE>";

		echo "</TD>";
		echo "</TR>";
		
		$color=""; $bg_img=""; $count_forum=0;
		$num_forum = $row[0];

		for($i=0; $i<$row[0]; $i++){
			$count++; $count_forum++;
		
			$row_forum = mysql_fetch_array($sql_forum);

			$sender=$row_forum["last_sender"];
			$date=$row_forum["last_date"];
			$id_post=$row_forum["last_id"];
					
			// Alternance des couleurs
			if($color==$PF["bg_line_1"]) $color=$PF["bg_line_2"]; else $color=$PF["bg_line_1"];
            if($bg_img==$PF["img_line_1"]) $bg_img=$PF["img_line_2"]; else $bg_img=$PF["img_line_1"];

			// Affiche une ligne des forums
			if(!empty($color)) echo "<TR bgcolor=$color id=\"row_$count\" $highlight>";
			else echo "<TR id=\"row_$count\" $highlight>"; 
				echo "<TD class=atk_forum width=34px align=center background='$bg_img'>";

					// Affiche le folder de la bonne couleur (pour nouveaux messages)
					$img=$PF["folder"]; $alt = $LANG["FORUM-NONEWMSG"];
					if(!empty($ATK_VISIT[$row_forum["id"]]) && $date>$ATK_VISIT[$row_forum["id"]]){
						$img=$PF["folder_new"];
						$alt = $LANG["FORUM-NEWMSG"];
					}
					if(empty($ATK_VISIT[$row_forum["id"]]) && $date>$LAST_VISIT_DEFAULT) {
						$img=$PF["folder_new"];
						$alt = $LANG["FORUM-NEWMSG"];
					}
					echo "<img border=0 src='$img' ALT='$alt' TITLE='$alt'>";

				echo "</TD>";
				echo "<TD class=atk_forum background='$bg_img'>";

					// Affiche le titre du forum
					if($BY_ID) echo "<a class=atk_post_tab href='./forum.php?fid=" . $row_forum["id"] . "'>" . $row_forum["title"] . "</a>";
					else echo "<a class=atk_post_tab href='" . $row_forum["filename"] . "'>" . $row_forum["title"] . "</a>";
					// Affiche [priv] si le forum est priv
					if($row_forum["passwd"] || $row_forum["log_login"] != "") echo "&nbsp;&nbsp;&nbsp;[" . $LANG["INDEX-FORUM-PRIVATE"] . "]";
					// Affiche [verrouill] si le forum est verrouill
					if($row_forum["locked"]) echo "&nbsp;&nbsp;&nbsp;[" . $LANG["INDEX-FORUM-LOCKED"] . "]";
					
					// On gre le dplacement des forums
					if($DROIT==2 && $num_forum>1){
						echo "&nbsp;&nbsp;&nbsp;&nbsp;";
						// On descent la rubrique
						if($count_forum<$num_forum){
							echo "<A href='" . $MYSELF . "action=move_forum&dir=down&id_forum=" . $row_forum["id"] . "'>";
							echo "<IMG src='images/down.gif' border=0>";
							echo "</A>";	
						}
						echo "&nbsp;&nbsp;";
						// On monte la rubrique
						if($count_forum>1){
							echo "<A href='" . $MYSELF . "action=move_forum&dir=up&id_forum=" . $row_forum["id"] . "'>";
							echo "<IMG src='images/up.gif' border=0>";
							echo "</A>";
						}					
					}
					
					echo "<BR>";
					// Affiche, si il existe, une courte description du forum
					$row_forum["subject"]=nl2br($row_forum["subject"]);
					if($row_forum["subject"]) echo $row_forum["subject"];

				echo "</TD>";
				if(!empty($PF["img_col"])) $img=$PF["img_col"]; else $img=$bg_img;
				if(!empty($PF["bg_col"])) echo "<TD class=atk_forum width=50px align=center background='$img' bgcolor='" . $PF["bg_col"] . "'>";
				else echo "<TD class=atk_forum width=50px align=center background='$img'>";

                    // Nombre de posts
					echo $row_forum[0];

				echo "</TD>";
				echo "<TD class=atk_forum align=center width=50px background='$bg_img'>";

					// Nombre de visite sur le forum
                    echo $row_forum["nb_visit"];

				echo "</TD>";

				if(!empty($PF["img_col"])) $img=$PF["img_col"]; else $img=$bg_img;
				if(!empty($PF["bg_col"])) echo "<TD class=atk_forum width=140px align=center background='$img' bgcolor='" . $PF["bg_col"] . "'>";
				else echo "<TD class=atk_forum width=140px align=center background='$img'>";

					// Affiche le dernier message et ses infos (date, auteur...)
					if($sender){
						if(!empty($CONNECTED_INDEX_USER[$sender])) echo "<IMG src='images/eclair_vert.gif' align=center ALT='" . $LANG["FORUM-CONNECTED-INDEX"] . "' TITLE='" . $LANG["FORUM-CONNECTED-INDEX"] . "'>&nbsp;";
						if($sender != "nobody" && !ereg("^-(.)*-$",$sender,$reg)) echo "<a class=atk_post_tab href='" . $MYSELF . "choix=5&method=3&login=" . $sender . "'>" . $sender . "</a>";
						elseif($sender != "nobody") echo $sender;
						else echo $LANG["NOBODY"];
						echo "&nbsp;";
						
						if($row_forum["structure"]<2){
							if($BY_ID) echo "<a class=atk_post_tab href='./forum.php?fid=" . $row_forum["id"] . "&msg=" . $id_post . "#" . $id_post . "'><IMG src='./images/view.gif' border=0 ALT='" . $LANG["FORUM-VIEW-LAST"] . "' TITLE='" . $LANG["FORUM-VIEW-LAST"] . "'></a>";
							else echo "<a class=atk_post_tab href='" . $row_forum["filename"] . "?msg=" . $id_post . "#" . $id_post . "'><IMG src='./images/view.gif' border=0 ALT='" . $LANG["FORUM-VIEW-LAST"] . "' TITLE='" . $LANG["FORUM-VIEW-LAST"] . "'></a>";
						} else {
							if($BY_ID) echo "<a class=atk_post_tab href='./forum.php?fid=" . $row_forum["id"] . "'><IMG src='./images/view.gif' border=0 ALT='" . $LANG["FORUM-VIEW-LAST"] . "' TITLE='" . $LANG["FORUM-VIEW-LAST"] . "'></a>";
							else echo "<a class=atk_post_tab href='" . $row_forum["filename"] . "'><IMG src='./images/view.gif' border=0 ALT='" . $LANG["FORUM-VIEW-LAST"] . "' TITLE='" . $LANG["FORUM-VIEW-LAST"] . "'></a>";
						}
						echo "<BR>";
						$date=date($LANG["FORMAT-DATE"],$date+($PF["local_time"]*3600));
						echo $date;
					} else echo "&nbsp;";

				echo "</TD>";
			echo "</TR>";

		}		

		echo "</TD></TR></TABLE>";

	}
}
?>
