<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

/*************************************/
/* affiche le formulaire de cration */
/* d'un nouveau forum                */
/*************************************/
function create_forum(){
	global $LANG, $PHP_SELF, $PRIV, $BY_ID, $DEFAULT_STYLE;

	// vrifie les droits avant l'affichage
	if(!$PRIV[0]) error(5);

	// Rcherche un nom de fichier non existant
	if(!$BY_ID){
		$n=0;
		do{
			$n++;
			$filename="forum_" . $n;
		} while(file_exists($filename . ".php"));
	}

	// Affichage du titre
	echo "<p class=atk_title>" . $LANG["ADMIN-CREATE-TITLE"] . "</p>";

	// Dbut du formulaire
	echo "<FORM method=post action='$PHP_SELF?action=create'>";

	echo "<TABLE width=100%>";
	echo "<TR><TD width=20%>";
			echo "<p class=atk_info align=right><b>" . $LANG["ADMIN-CREATE-TITLE-FORUM"] . ":</b>";
		echo "</TD>";
		echo "<TD width=50%>";
			echo "<INPUT class=atk_input type=text name='title' size=44>";
	echo "</TD></TR>";

	// demande le nom du fichier si ncessaire
	if(!$BY_ID){
		echo "<TR><TD>";
				echo "<p class=atk_info align=right><b>" . $LANG["ADMIN-CREATE-FILENAME"] . ":</b>";
			echo "</TD>";
			echo "<TD width=50%>";
				echo "<p class=atk_info><INPUT class=atk_input type=text name='filename' size=10 value='$filename'>.php";
		echo "</TD></TR>";
	}

	echo "<TR><TD>";
			echo "<p class=atk_info align=right><b>" . $LANG["ADMIN-CREATE-PASSWD"] . ":</b>";
		echo "</TD>";
		echo "<TD width=50%>";
			echo "<p class=atk_info><INPUT class=atk_input type=text name='passwd' size=10>";
	echo "</TD></TR>";

	echo "<TR><TD>";
			echo "<p class=atk_info align=right><b>" . $LANG["ADMIN-CREATE-STYLE"] . ":</b>";
		echo "</TD>";
		echo "<TD width=50%>";
			echo "<SELECT class=atk_input name='style'>";
				echo "<option value=''><b>" . $LANG["ADMIN-CREATE-CHOOSE-STYLE"] . "</b></option>";
				echo "<option value=''>--------------------</option>";

				echo "<option value=''>" . $LANG["ADMIN-CREATE-PREDEFINED"] . "</option>";
				// Rcupre le nom des fichiers de styles
				$row = getstylefile();
				for($i=0; $i<count($row); $i++){
					if($row[$i]==$DEFAULT_STYLE) $option="SELECTED"; else $option="";
					echo "<option value='xml_" . $row[$i] . "' $option>--&nbsp;" . cut_text($row[$i],60) . "</option>";
				}
				echo "<option value=''>--------------------</option>";
				echo "<option value=''><b>" . $LANG["ADMIN-CREATE-APPLY-STYLE"] . "</b></option>";
				// Recherche le nom de tous les forums pour l'affichage
				$sql=dbquery("SELECT id,title FROM atk_forums",17,37);
				dbclose();
				while($row = mysql_fetch_array($sql))
					echo "<option value='fid_" . $row["id"] . "'>--&nbsp;" . cut_text($row["title"],60) . "</option>";
			echo "</STYLE>";
	echo "</TD></TR>";

	echo "<TR><TD>";
			echo "<p class=atk_info align=right><b>" . $LANG["ADMIN-CREATE-TABLEAU"] . ":</b>";
		echo "</TD>";
		echo "<TD width=50%>";
			echo "<p class=atk_info>&nbsp;";
			
			echo "<INPUT type=radio name='structure' value='1' CHECKED> " . $LANG["ADMIN-CREATE-TAB"];
			echo "&nbsp;&nbsp;&nbsp;&nbsp;";
			echo "<INPUT type=radio name='structure' value='0'> " . $LANG["ADMIN-CREATE-CLASSIC"];
			
			echo "<BR>&nbsp;";
			
			echo "<INPUT type=radio name='structure' value='2'> " . $LANG["ADMIN-OPTION-ADVANCED-14-CHOOSE-3"];
			echo "&nbsp;&nbsp;&nbsp;&nbsp;";
			echo "<INPUT type=radio name='structure' value='3'> " . $LANG["ADMIN-OPTION-ADVANCED-14-CHOOSE-4"];
		
	echo "</TD></TR>";
	echo "<TR><TD>";
			echo "<p class=atk_info align=right><b>" . $LANG["ADMIN-CREATE-DESCRIPTION"] . ":</b>";
		echo "</TD>";
		echo "<TD width=50%>";
			echo "<textarea class=atk_input name='subject' cols=44 rows=5></textarea>";
	echo "</TD></TR>";
	echo "</TABLE>";

	echo "<br><center><INPUT type=submit value='" . $LANG["INPUT-OK"] . "'></center>";

	echo "</FORM>";
}
?>
