<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

/**************************************************/
/* Redirige l'excution vers les bonnes fonctions */
/* en fonction des paramtres                     */
/**************************************************/
function gest_forum($id, $rub, $msg){

	if($id==0) select_forum();
	if($id!=0 && $rub==0) change_forum($id,$msg);

	// Choix de la rubrique
	if($id!=0 && $rub!=0)
		switch($rub){
			case 1:	modify_color($id); break;
			case 2:	modify_img($id); break;
			case 3:	modify_perso($id); break;
			case 4:	modify_email($id); break;
			case 5:	modify_other($id); break;
			case 6:	modify_passwd($id); break;
			case 7:	modify_police($id); break;
			case 8:	modify_style($id); break;
		}
}

/***********************************/
/* Slection du forum  paramtrer */
/***********************************/
function select_forum(){
	global $LANG, $ATK_LOGIN, $DROIT, $PRIV, $PHP_SELF;

	echo "<p class=atk_title>" . $LANG["ADMIN-FORUMS-TITLE"] . "</p>";

	// Vrification des droits
	$option=""; $flag=0;
	// Droit sur certain forums, mais pas tous
	if(empty($PRIV[4])){
		$query = "
			SELECT id, title, droit
			FROM atk_forums, atk_admin
			WHERE atk_admin.login = '$ATK_LOGIN'
			AND atk_forums.id = atk_admin.forum";
		$sql = dbquery($query);
		while($row = mysql_fetch_array($sql)){
			$priv = strrev(decbin($row["droit"]));
			if($priv[0]){
				$option .= "<OPTION value='" . $row["id"] . "'>" . cut_text($row["title"],80) . "</OPTION>";
				if(!$flag) $flag=1;
			}
		}
	// Droit sur tous les forums
	} else {
		$sql=dbquery("SELECT id,title FROM atk_forums");
		while($row=mysql_fetch_array($sql)){
			$option .= "<OPTION value='" . $row["id"] . "'>" . cut_text($row["title"],80) . "</OPTION>";
			if(!$flag) $flag=1;
		}
	}

	// Si il existe des forums dans la liste
	if($flag){
		echo "<FORM method=post action='$PHP_SELF?choix=3'>";

		echo "<p class=atk_info align=center><b>" . $LANG["ADMIN-FORUMS-CHOOSE"] . " :</b>";
		echo "<br><br>";

			echo "<SELECT class=atk_input name=id>";
			echo $option;
			echo "</SELECT>";
			echo "<br><br>";
			echo "<INPUT type=submit value='" . $LANG["INPUT-OK"] . "'>";

		echo "</FORM>";
	// Il n'a pas les droits sur aucun forum
	} else {
		echo "<br><p class=atk_info align=center><b>" . $LANG["ADMIN-FORUMS-NOMORE"] . "</b>";
	}
}

/*****************************************/
/* Slection de la rubrique  paramtrer */
/*****************************************/
function change_forum($id, $msg){
	global $PHP_SELF, $LANG, $BY_ID;

	// Recherche le nom du forum
	$row=dbgetline("SELECT title,filename FROM atk_forums WHERE id=$id");
	dbclose();

	// Affichage du titre du menu gnral
	if(!$BY_ID) echo "<p class=atk_title>" . $LANG["ADMIN-FORUMS-PARAM"] . ": <a class=atk_title href='" . $row["filename"] . "' target='_blank'>" . $row["title"] . "</a>";
	else echo "<p class=atk_title>" . $LANG["ADMIN-FORUMS-PARAM"] . ": <a class=atk_title href='./forum.php?fid=$id' target='_blank'>" . $row["title"] . "</a>";
	echo "<BR><a class=atk_lien href='$PHP_SELF?choix=3'>" . $LANG["ADMIN-FORUMS-RETURN-1"] . "</a></p>";

	// Affichage des messages de confirmation
	if($msg) show_message($msg);

	echo "<TABLE width=100% cellspacing=14px>";
	echo "<TR><TD width=160px valign=top>";
		echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id&rub=8'>" . $LANG["ADMIN-FORUMS-MENU-8"] . "</a>";
	echo "</TD><TD valign=top>";
		echo "<p class=atk_info>" . $LANG["ADMIN-FORUMS-MENU-8bis"];
	echo "</TD></TR>";
	echo "<TR><TD width=160px valign=top>";
		echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id&rub=1'>" . $LANG["ADMIN-FORUMS-MENU-1"] . "</a>";
	echo "</TD><TD valign=top>";
		echo "<p class=atk_info>" . $LANG["ADMIN-FORUMS-MENU-1bis"];
	echo "</TD></TR>";
	echo "<TR><TD width=160px valign=top>";
		echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id&rub=2'>" . $LANG["ADMIN-FORUMS-MENU-2"] . "</a>";
	echo "</TD><TD valign=top>";
		echo "<p class=atk_info>" . $LANG["ADMIN-FORUMS-MENU-2bis"];
	echo "</TD></TR>";
	echo "<TR><TD width=160px valign=top>";
		echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id&rub=7'>" . $LANG["ADMIN-FORUMS-MENU-7"] . "</a>";
	echo "</TD><TD valign=top>";
		echo "<p class=atk_info>" . $LANG["ADMIN-FORUMS-MENU-7bis"];
	echo "</TD></TR>";
	echo "<TR><TD width=160px valign=top>";
		echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id&rub=3'>" . $LANG["ADMIN-FORUMS-MENU-3"] . "</a>";
	echo "</TD><TD valign=top>";
		echo "<p class=atk_info>" . $LANG["ADMIN-FORUMS-MENU-3bis"];
	echo "</TD></TR>";
	echo "<TR><TD width=160px valign=top>";
		echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id&rub=5'>" . $LANG["ADMIN-FORUMS-MENU-5"] . "</a>";
	echo "</TD><TD valign=top>";
		echo "<p class=atk_info>" . $LANG["ADMIN-FORUMS-MENU-5bis"];
	echo "</TD></TR>";
	echo "<TR><TD width=160px valign=top>";
		echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id&rub=4'>" . $LANG["ADMIN-FORUMS-MENU-4"] . "</a>";
	echo "</TD><TD valign=top>";
		echo "<p class=atk_info>" . $LANG["ADMIN-FORUMS-MENU-4bis"];
	echo "</TD></TR>";
	echo "<TR><TD width=160px valign=top>";
		echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id&rub=6'>" . $LANG["ADMIN-FORUMS-MENU-6"] . "</a>";
	echo "</TD><TD valign=top>";
		echo "<p class=atk_info>" . $LANG["ADMIN-FORUMS-MENU-6bis"];
	echo "</TD></TR>";
	echo "</TABLE>";

	echo "<p class=atk_info align=center>" . $LANG["ADMIN-FORUMS-INFO-DEL"];

	echo "<BR><BR>";
}

/******************************/
/* Applique un style au forum */
/******************************/
function modify_style($id){
	global $LANG, $PHP_SELF;

	// Rcupre les anciennes valeurs
	$query = "SELECT title FROM atk_forums WHERE id='$id'";
	$title = dbgetfirst($query);

	// Recherche le nom de tous les forums pour l'affichage
	$sql_forum = dbquery("SELECT id,title FROM atk_forums");
	dbclose();

	echo "<p class=atk_title>" . $LANG["ADMIN-FORUMS-STYLE"] . ": $title<br>";
	echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id'>" . $LANG["ADMIN-FORUMS-RETURN-2"] . "</a></p>";

	echo "<FORM name=form method=post action='$PHP_SELF?action=rec_style_forum&id=$id&choix=3'>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-STYLE-1"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-STYLE-1"] . " :</b>";
		echo "</TD><TD>";
			echo "<SELECT class=atk_input name='id_from'>";
				// Recherche le nom de tous les forums pour l'affichage
				while($row=mysql_fetch_array($sql_forum))
					echo "<option value='" . $row["id"] . "'>" . cut_text($row["title"],80) . "</option>";
			echo "</STYLE>";
		echo "</TD></TR>";
		echo "</TABLE><BR>";

	echo "<center><INPUT type=submit value='" . $LANG["INPUT-OK"] . "'></center>";

	echo "</FORM>";
	
	echo "<BR>";

	echo "<FORM name=form method=post action='$PHP_SELF?action=rec_style_xml&id=$id&choix=3'>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-STYLE-2"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-STYLE-1"] . " :</b>";
		echo "</TD><TD>";
			echo "<SELECT class=atk_input name='dirname'>";
				// Recherche le nom de tous les forums pour l'affichage
				$style = getstylefile();
				for($i=0;$i<count($style); $i++)
					echo "<option value='" . $style[$i] . "'>" . cut_text($style[$i],80) . "</option>";
			echo "</STYLE>";
		echo "</TD></TR>";
		echo "</TABLE><BR>";

	echo "<center><INPUT type=submit value='" . $LANG["INPUT-OK"] . "'></center>";

	echo "</FORM>";

     echo "<BR>";

	echo "<FORM name=form method=post action='$PHP_SELF?action=export_style&id=$id&choix=3'>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-CREATE-STYLE-FILE"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-STYLE-2"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input name='stylename' size=28>";
		echo "</TD></TR>";
		echo "</TABLE><BR>";

	echo "<center><INPUT type=submit value='" . $LANG["INPUT-OK"] . "'></center>";

	echo "</FORM>";
	
	echo "<BR><BR>";
}

/*************************************/
/* affichage des flches de couleurs */
/*************************************/
function color($num, $default){
	global $HTTP_USER_AGENT, $LANG;

	if(eregi('msie',$HTTP_USER_AGENT) && !eregi('opera',$HTTP_USER_AGENT)){
		if(empty($default)) $default="#000000";

		echo "<TABLE align=left border=1 bordercolor=#000000 cellspacing=0 id='tab" . $num . "' bgcolor='" . $default . "'>";
		echo "<TR><TD width=34px height=20px></TD>";
		echo "</TR></TABLE>";

		echo "<IMG src='./images/up_red.gif' alt='" . $LANG["MORE-RED"] . "' ondblclick='javascript:more_red($num)' onclick='javascript:more_red($num)'>";
		echo "<IMG src='./images/up_green.gif' alt='" . $LANG["MORE-GREEN"] . "' ondblclick='javascript:more_green($num)' onclick='javascript:more_green($num)'>";
		echo "<IMG src='./images/up_blue.gif' alt='" . $LANG["MORE-BLUE"] . "' ondblclick='javascript:more_blue($num)' onclick='javascript:more_blue($num)'>";
		echo "<BR>";
		echo "<IMG src='./images/down_red.gif' alt='" . $LANG["LESS-RED"] . "' ondblclick='javascript:less_red($num)' onclick='javascript:less_red($num)'>";
		echo "<IMG src='./images/down_green.gif' alt='" . $LANG["LESS-GREEN"] . "' ondblclick='javascript:less_green($num)' onclick='javascript:less_green($num)'>";
		echo "<IMG src='./images/down_blue.gif' alt='" . $LANG["LESS-BLUE"] . "' ondblclick='javascript:less_blue($num)' onclick='javascript:less_blue($num)'>";
	}
}

/****************************************************/
/* Affiche la rubrique de modification des couleurs */
/****************************************************/
function modify_color($id){
	global $PHP_SELF, $LANG;
	global $HTTP_USER_AGENT;

	// Vrifie le navigateur, seul IE supporte le javascript ColorProcess.js
	$nav=0;
	if(eregi("msie",$HTTP_USER_AGENT) && !eregi("opera",$HTTP_USER_AGENT)) $nav=1;
	// Inclusion du javascript
	if($nav==1) echo "<SCRIPT language='JavaScript' src='javascript/ColorProcess.js' type='text/javascript'></SCRIPT>";

	// Rcupre les anciennes valeurs
	$row=dbgetline("SELECT * FROM atk_forums WHERE id=$id");
	dbclose();

	// Titre de la rubrique
	echo "<p class=atk_title>" . $LANG["ADMIN-FORUMS-COLOR"] . ": " . $row["title"] . "<br>";
	echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id'>" . $LANG["ADMIN-FORUMS-RETURN-2"] . "</a></p>";

	echo "<p class=atk_info align=center>" . $LANG["ADMIN-FORUMS-COLOR-6"];

     echo "<BR><BR>";

	echo "<TABLE>";
	echo "<TR><TD bgcolor=#FFEECC>";
		echo "<p class=atk_info align=center>" . $LANG["ADMIN-COLORS-ORANGE"];
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#AAEEBB>";
		echo "<p class=atk_info align=center>" . $LANG["ADMIN-COLORS-GREEN"];
	echo "</TD></TR>";
	echo "</TABLE>";

	echo "<FORM name=form method=post action='$PHP_SELF?action=rec_colors&id=$id&choix=3'>";

	// Bouton OK
	echo "<p align=center><INPUT type=submit value='" . $LANG["INPUT-OK"] . "'>";

	/***************************/
	/* Bloc couleurs gnrales */
	/***************************/
	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-COLOR-1"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-1"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(1);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[bg_color]' id='1' value='" . $row["bg_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(1, $row["bg_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-2"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(2);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[bg_body_color]' id='2' value='" . $row["bg_body_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(2, $row["bg_body_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-44"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(2);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[bg_body_color_new]' id='44' value='" . $row["bg_body_color_new"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(44, $row["bg_body_color_new"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-3"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(3);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[bg_title_color]' id='3' value='" . $row["bg_title_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(3, $row["bg_title_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-4"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(4);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[border_color]' id='4' value='" . $row["border_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(4, $row["border_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-WIDTH-4"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<p class=atk_info><INPUT class=atk_input type=text size=1 name='PARAM[border_width]' value='" . $row["border_width"] . "'>px";
	echo "</TD><TD>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-5"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(5);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[table_bg_color]' id='5' value='" . $row["table_bg_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(5, $row["table_bg_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-6"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(6);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[table_border_color]' id='6' value='" . $row["table_border_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(6, $row["table_border_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-7"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(7);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[del_mess_bg_color]' id='7' value='" . $row["del_mess_bg_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(7, $row["del_mess_bg_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-8"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(8);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[bg_line_1]' id='8' value='" . $row["bg_line_1"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(8, $row["bg_line_1"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-9"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(9);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[bg_line_2]' id='9' value='" . $row["bg_line_2"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(9, $row["bg_line_2"]);
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#FFEECC>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-10"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(10);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[bg_post_it]' id='10' value='" . $row["bg_post_it"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(10, $row["bg_post_it"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-45"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(45);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[bg_ssmenu]' id='45' value='" . $row["bg_ssmenu"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(45, $row["bg_ssmenu"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-47"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(47);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[bg_col]' id='47' value='" . $row["bg_col"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(47, $row["bg_col"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-42"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(42);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[bg_highlight]' id='42' value='" . $row["bg_highlight"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(42, $row["bg_highlight"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-43"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(43);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[bg_onclick]' id='43' value='" . $row["bg_onclick"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(43, $row["bg_onclick"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-11"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(12);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[separation]' id='11' value='" . $row["separation"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(11, $row["separation"]);
	echo "</TD></TR>";
	echo "</TABLE>";

	/****************************/
	/* Bloc couleur des polices */
	/****************************/
	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-COLOR-2"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-12"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(12);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[title_color]' id='12' value='" . $row["title_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(12, $row["title_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-13"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(13);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[intro_color]' id='13' value='" . $row["intro_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(13, $row["intro_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-14"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(14);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[menu_color]' id='14' value='" . $row["menu_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(14, $row["menu_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-15"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(15);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[menu_color_a]' id='15' value='" . $row["menu_color_a"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(15, $row["menu_color_a"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-16"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(16);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[selected_color]' id='16' value='" . $row["selected_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(16, $row["selected_color"]);
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#FFEECC>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-17"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(17);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[post_color_tab]' id='17' value='" . $row["post_color_tab"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(17, $row["post_color_tab"]);
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#FFEECC>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-18"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(18);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[post_color_a_tab]' id='18' value='" . $row["post_color_a_tab"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(18, $row["post_color_a_tab"]);
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#FFEECC>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-19"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(19);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[post_color_v_tab]' id='19' value='" . $row["post_color_v_tab"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(19, $row["post_color_v_tab"]);
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#AAEEBB>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-20"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(20);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[post_color_arbo]' id='20' value='" . $row["post_color_arbo"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(20, $row["post_color_arbo"]);
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#AAEEBB>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-21"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(21);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[post_color_a_arbo]' id='21' value='" . $row["post_color_a_arbo"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(21, $row["post_color_a_arbo"]);
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#AAEEBB>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-22"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(22);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[post_color_v_arbo]' id='22' value='" . $row["post_color_v_arbo"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(22, $row["post_color_v_arbo"]);
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#AAEEBB>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-23"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(23);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[post_it_color]' id='23' value='" . $row["post_it_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(23, $row["post_it_color"]);
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#AAEEBB>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-24"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(24);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[post_it_color_a]' id='24' value='" . $row["post_it_color_a"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(24, $row["post_it_color_a"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-46"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(46);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[ssmenu_color]' id='46' value='" . $row["ssmenu_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(46, $row["ssmenu_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-25"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(25);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[link_color]' id='25' value='" . $row["link_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(25, $row["link_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-26"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(26);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[link_color_a]' id='26' value='" . $row["link_color_a"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(26, $row["link_color_a"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-27"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(27);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[text_color]' id='27' value='" . $row["text_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(27, $row["text_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-48"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(48);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[button_link_color]' id='48' value='" . $row["button_link_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(48, $row["button_link_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-49"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(49);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[button_link_color_a]' id='49' value='" . $row["button_link_color_a"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(49, $row["button_link_color_a"]);
	echo "</TD></TR>";
	echo "</TABLE>";

	/****************************/
	/* Bloc Couleur des boutons */
	/****************************/
	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-COLOR-3"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-28"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(28);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[input_text_color]' id='28' value='" . $row["input_text_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(28, $row["input_text_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-29"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(29);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[input_bg_color]' id='29' value='" . $row["input_bg_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(29, $row["input_bg_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-30"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(30);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[input_border_color]' id='30' value='" . $row["input_border_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(30, $row["input_border_color"]);
	echo "</TD></TR>";
	echo "</TABLE>";

	/***************************/
	/* Couleur de la scrollbar */
	/***************************/
	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-COLOR-4"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-34"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(34);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[scrollbar_base_color]' id='34' value='" . $row["scrollbar_base_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(34, $row["scrollbar_base_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-35"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(35);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[scrollbar_face_color]' id='35' value='" . $row["scrollbar_face_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(35, $row["scrollbar_face_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-36"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(36);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[scrollbar_highlight_color]' id='36' value='" . $row["scrollbar_highlight_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(36, $row["scrollbar_highlight_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-37"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(37);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[scrollbar_shadow_color]' id='37' value='" . $row["scrollbar_shadow_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(37, $row["scrollbar_shadow_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-38"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(38);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[scrollbar_3dlight_color]' id='38' value='" . $row["scrollbar_3dlight_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(38, $row["scrollbar_3dlight_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-39"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(39);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[scrollbar_arrow_color]' id='39' value='" . $row["scrollbar_arrow_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(39, $row["scrollbar_arrow_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-40"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(40);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[scrollbar_track_color]' id='40' value='" . $row["scrollbar_track_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(40, $row["scrollbar_track_color"]);
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-COLOR-41"] . " :</b>";
	echo "</TD><TD width=100px>";
		if($nav==1) $Refresh="OnKeyUp=\"refresh(41);\""; else $Refresh="";
		echo "<INPUT class=atk_input type=text size=10 name='PARAM[scrollbar_darkshadow_color]' id='41' value='" . $row["scrollbar_darkshadow_color"] . "' " . $Refresh . ">";
	echo "</TD><TD>";
		color(41, $row["scrollbar_darkshadow_color"]);
	echo "</TD></TR>";
	echo "</TABLE>";

	// Affichage du bas du formulaire
	echo "<br>";

	echo "<p class=atk_info align=center><b>" . $LANG["ADMIN-FORUMS-COLOR-5"] . "</b></p>";

	echo "<p align=center><INPUT type=submit value='" . $LANG["INPUT-OK"] . "'>";

	echo "</FORM>";
}

/**************************************************/
/* Affiche la rubrique de modification des images */
/**************************************************/
function modify_img($id){
	global $PHP_SELF, $LANG;

	// Rcupre les anciennes valeurs
	$query = "
		SELECT title, bg_img, img_fixed, bg_img_tab,
		bg_img_tab_title, img_line_1, img_line_2, img_col,
		img_post_it, img_ssmenu, img_new, puce_post_it, bg_img_tab_new,
		folder, folder_new, folder_fire, folder_new_fire, puce_post_it_new,
		folder_poll, folder_poll_new,
		button,
		poll_left_bar, poll_middle_bar, poll_right_bar
		FROM atk_forums
		WHERE id=$id";
	$sql = dbquery($query);
	dbclose();
	$row=mysql_fetch_array($sql);

	echo "<p class=atk_title>" . $LANG["ADMIN-FORUMS-IMG"] . ": " . $row["title"] . "<br>";
	echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id'>" . $LANG["ADMIN-FORUMS-RETURN-2"] . "</a></p>";

	echo "<p align=center><TABLE>";
	echo "<TR><TD bgcolor=#FFEECC>";
		echo "<p class=atk_info align=center>" . $LANG["ADMIN-COLORS-ORANGE"];
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#AAEEBB>";
		echo "<p class=atk_info align=center>" . $LANG["ADMIN-COLORS-GREEN"];
	echo "</TD></TR>";
	echo "</TABLE>";

	echo "<FORM name=form method=post action='$PHP_SELF?action=rec_img&id=$id&choix=3'>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-IMG-1"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-1"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[bg_img]' value='" . $row["bg_img"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
	echo "</TD><TD width=100px>";
		if($row["img_fixed"]==1) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[img_fixed]' value='1' $option> " . $LANG["ADMIN-OPTION-IMG-2"];
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-3"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[bg_img_tab]' value='" . $row["bg_img_tab"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-14"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[bg_img_tab_new]' value='" . $row["bg_img_tab_new"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-4"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[bg_img_tab_title]' value='" . $row["bg_img_tab_title"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-5"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[img_line_1]' value='" . $row["img_line_1"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-6"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[img_line_2]' value='" . $row["img_line_2"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#FFEECC>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-7"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[img_post_it]' value='" . $row["img_post_it"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-15"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[img_ssmenu]' value='" . $row["img_ssmenu"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-20"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[img_col]' value='" . $row["img_col"] . "'>";
	echo "</TD></TR>";
	echo "</TABLE>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-IMG-2"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px>";
	echo "<TR><TD width=180px bgcolor=#AAEEBB>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-8"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[img_new]' value='" . $row["img_new"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-9"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[folder]' value='" . $row["folder"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-10"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[folder_new]' value='" . $row["folder_new"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD width=180px bgcolor=#FFEECC>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-11"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[folder_fire]' value='" . $row["folder_fire"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD width=180px bgcolor=#FFEECC>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-12"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[folder_new_fire]' value='" . $row["folder_new_fire"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-13"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[puce_post_it]' value='" . $row["puce_post_it"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-16"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[puce_post_it_new]' value='" . $row["puce_post_it_new"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-21"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[folder_poll]' value='" . $row["folder_poll"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-22"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[folder_poll_new]' value='" . $row["folder_poll_new"] . "'>";
	echo "</TD></TR>";	
	echo "</TABLE>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-IMG-4"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-17"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[button]' value='" . $row["button"] . "'>";
	echo "</TD></TR>";
	echo "</TABLE>";
	
	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-IMG-5"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-24"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[poll_left_bar]' value='" . $row["poll_left_bar"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-25"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[poll_middle_bar]' value='" . $row["poll_middle_bar"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-IMG-26"] . " :</b>";
	echo "</TD><TD width=100px>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[poll_right_bar]' value='" . $row["poll_right_bar"] . "'>";
	echo "</TD></TR>";
	echo "</TABLE>";
	
	echo "<br>";

	echo "<p class=atk_info align=center>" . $LANG["ADMIN-FORUMS-IMG-3"] . "</p>";

	echo "<center><INPUT type=submit value='" . $LANG["INPUT-OK"] . "'></center>";

	echo "</FORM>";

}

/*************************************/
/* Modification des polices du forum */
/*************************************/
function modify_police($id){
	global $PHP_SELF, $LANG;

	// Rcupre les anciennes valeurs
	$query = "SELECT * FROM atk_forums WHERE id=$id";
	$row = dbgetline($query);
	dbclose();

	echo "<p class=atk_title>" . $LANG["ADMIN-FORUMS-POLICE"] . ": " . $row["title"] . "<br>";
	echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id'>" . $LANG["ADMIN-FORUMS-RETURN-2"] . "</a></p>";

	echo "<FORM name=form method=post action='$PHP_SELF?action=rec_police&id=$id&choix=3'>";

     echo "<center><INPUT type=submit value='" . $LANG["INPUT-OK"] . "'></center>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-POLICE-1"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-1"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=title size=22 name='PARAM[font_title]' value='" . $row["font_title"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-2"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=title size=3 name='PARAM[size_title]' value='" . $row["size_title"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-3"] . " :</b>";
		echo "</TD><TD>";
			$style=strrev(decbin($row["style_title"]));
			echo "<p class=atk_info>";
			if(isset($style[0]) AND $style[0]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT type=checkbox name='PARAM[bold_title]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-4"];
			echo "&nbsp;&nbsp;";
			if(isset($style[1]) AND $style[1]) $checked="CHECKED"; else $checked="";
			echo "<INPUT type=checkbox name='PARAM[italic_title]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-5"];
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-6"] . " :</b>";
		echo "</TD><TD>";
			echo "<p class=atk_info>";
			if((!isset($style[2]) OR !$style[2]) AND (!isset($style[3]) OR !$style[3]) AND (!isset($style[4]) OR !$style[4])) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_title]' type=radio value=0 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-7"];
			echo "&nbsp;&nbsp;";
			if(isset($style[2]) AND $style[2]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_title]' type=radio value=1 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-8"];
			echo "&nbsp;&nbsp;";
			if(isset($style[3]) AND $style[3]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_title]' type=radio value=2 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-9"];
			echo "&nbsp;&nbsp;";
			if(isset($style[4]) AND $style[4]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_title]' type=radio value=3 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-10"];
		echo "</TD></TR>";
		echo "</TABLE>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-POLICE-2"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-1"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=intro size=22 name='PARAM[font_intro]' value='" . $row["font_intro"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-2"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=intro size=3 name='PARAM[size_intro]' value='" . $row["size_intro"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-3"] . " :</b>";
		echo "</TD><TD>";
			$style=strrev(decbin($row["style_intro"]));
			echo "<p class=atk_info>";
			if(isset($style[0]) AND $style[0]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT type=checkbox name='PARAM[bold_intro]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-4"];
			echo "&nbsp;&nbsp;";
			if(isset($style[1]) AND $style[1]) $checked="CHECKED"; else $checked="";
			echo "<INPUT type=checkbox name='PARAM[italic_intro]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-5"];
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-6"] . " :</b>";
		echo "</TD><TD>";
			echo "<p class=atk_info>";
			if((!isset($style[2]) OR !$style[2]) AND (!isset($style[3]) OR !$style[3]) AND (!isset($style[4]) OR !$style[4])) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_intro]' type=radio value=0 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-7"];
			echo "&nbsp;&nbsp;";
			if(isset($style[2]) AND $style[2]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_intro]' type=radio value=1 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-8"];
			echo "&nbsp;&nbsp;";
			if(isset($style[3]) AND $style[3]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_intro]' type=radio value=2 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-9"];
			echo "&nbsp;&nbsp;";
			if(isset($style[4]) AND $style[4]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_intro]' type=radio value=3 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-10"];
		echo "</TD></TR>";
		echo "</TABLE>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-POLICE-3"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-1"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=22 name='PARAM[font_text]' value='" . $row["font_text"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-2"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=3 name='PARAM[size_text]' value='" . $row["size_text"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-3"] . " :</b>";
		echo "</TD><TD>";
			$style=strrev(decbin($row["style_text"]));
			echo "<p class=atk_info>";
			if(isset($style[0]) AND $style[0]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT type=checkbox name='PARAM[bold_text]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-4"];
			echo "&nbsp;&nbsp;";
			if(isset($style[1]) AND $style[1]) $checked="CHECKED"; else $checked="";
			echo "<INPUT type=checkbox name='PARAM[italic_text]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-5"];
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-6"] . " :</b>";
		echo "</TD><TD>";
			echo "<p class=atk_info>";
			if((!isset($style[2]) OR !$style[2]) AND (!isset($style[3]) OR !$style[3]) AND (!isset($style[4]) OR !$style[4])) $checked="CHECKED"; else $checked="";
			echo "<INPUT name=deco_text type=radio value=0 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-7"];
			echo "&nbsp;&nbsp;";
			if(isset($style[2]) AND $style[2]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_text]' type=radio value=1 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-8"];
			echo "&nbsp;&nbsp;";
			if(isset($style[3]) AND $style[3]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_text]' type=radio value=2 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-9"];
			echo "&nbsp;&nbsp;";
			if(isset($style[4]) AND $style[4]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_text]' type=radio value=3 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-10"];
		echo "</TD></TR>";
		echo "</TABLE>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-POLICE-4"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-1"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=22 name='PARAM[font_menu]' value='" . $row["font_menu"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-2"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=3 name='PARAM[size_menu]' value='" . $row["size_menu"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-3"] . " :</b>";
		echo "</TD><TD>";
			$style=strrev(decbin($row["style_menu"]));
			echo "<p class=atk_info>";
			if(isset($style[0]) AND $style[0]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT type=checkbox name='PARAM[bold_menu]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-4"];
			echo "&nbsp;&nbsp;";
			if(isset($style[1]) AND $style[1]) $checked="CHECKED"; else $checked="";
			echo "<INPUT type=checkbox name='PARAM[italic_menu]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-5"];
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-6"] . " :</b>";
		echo "</TD><TD>";
			echo "<p class=atk_info>";
			if((!isset($style[2]) OR !$style[2]) AND (!isset($style[3]) OR !$style[3]) AND (!isset($style[4]) OR !$style[4])) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_menu]' type=radio value=0 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-7"];
			echo "&nbsp;&nbsp;";
			if(isset($style[2]) AND $style[2]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_menu]' type=radio value=1 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-8"];
			echo "&nbsp;&nbsp;";
			if(isset($style[3]) AND $style[3]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_menu]' type=radio value=2 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-9"];
			echo "&nbsp;&nbsp;";
			if(isset($style[4]) AND $style[4]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_menu]' type=radio value=3 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-10"];
		echo "</TD></TR>";
		echo "</TABLE>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-POLICE-5"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-1"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=22 name='PARAM[font_menu_a]' value='" . $row["font_menu_a"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-2"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=3 name='PARAM[size_menu_a]' value='" . $row["size_menu_a"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-3"] . " :</b>";
		echo "</TD><TD>";
			$style=strrev(decbin($row["style_menu_a"]));
			echo "<p class=atk_info>";
			if(isset($style[0]) AND $style[0]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT type=checkbox name='PARAM[bold_menu_a]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-4"];
			echo "&nbsp;&nbsp;";
			if(isset($style[1]) AND $style[1]) $checked="CHECKED"; else $checked="";
			echo "<INPUT type=checkbox name='PARAM[italic_menu_a]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-5"];
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-6"] . " :</b>";
		echo "</TD><TD>";
			echo "<p class=atk_info>";
			if((!isset($style[2]) OR !$style[2]) AND (!isset($style[3]) OR !$style[3]) AND (!isset($style[4]) OR !$style[4])) $checked="CHECKED"; else $checked="";
			echo "<INPUT name='PARAM[deco_menu_a]' type=radio value=0 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-7"];
			echo "&nbsp;&nbsp;";
			if(isset($style[2]) AND $style[2]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_menu_a]' type=radio value=1 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-8"];
			echo "&nbsp;&nbsp;";
			if(isset($style[3]) AND $style[3]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_menu_a]' type=radio value=2 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-9"];
			echo "&nbsp;&nbsp;";
			if(isset($style[4]) AND $style[4]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_menu_a]' type=radio value=3 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-10"];
		echo "</TD></TR>";
		echo "</TABLE>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-POLICE-6"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-1"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=22 name='PARAM[font_post]' value='" . $row["font_post"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-2"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=3 name='PARAM[size_post]' value='" . $row["size_post"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-3"] . " :</b>";
		echo "</TD><TD>";
			$style=strrev(decbin($row["style_post"]));
			echo "<p class=atk_info>";
			if(isset($style[0]) AND $style[0]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT type=checkbox name='PARAM[bold_post]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-4"];
			echo "&nbsp;&nbsp;";
			if(isset($style[1]) AND $style[1]) $checked="CHECKED"; else $checked="";
			echo "<INPUT type=checkbox name='PARAM[italic_post]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-5"];
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-6"] . " :</b>";
		echo "</TD><TD>";
			echo "<p class=atk_info>";
			if((!isset($style[2]) OR !$style[2]) AND (!isset($style[3]) OR !$style[3]) AND (!isset($style[4]) OR !$style[4])) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_post]' type=radio value=0 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-7"];
			echo "&nbsp;&nbsp;";
			if(isset($style[2]) AND $style[2]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_post]' type=radio value=1 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-8"];
			echo "&nbsp;&nbsp;";
			if(isset($style[3]) AND $style[3]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_post]' type=radio value=2 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-9"];
			echo "&nbsp;&nbsp;";
			if(isset($style[4]) AND $style[4]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_post]' type=radio value=3 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-10"];
		echo "</TD></TR>";
		echo "</TABLE>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-POLICE-7"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-1"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=22 name='PARAM[font_post_a]' value='" . $row["font_post_a"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-2"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=3 name='PARAM[size_post_a]' value='" . $row["size_post_a"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-3"] . " :</b>";
		echo "</TD><TD>";
			$style=strrev(decbin($row["style_post_a"]));
			echo "<p class=atk_info>";
			if(isset($style[0]) AND $style[0]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT type=checkbox name='PARAM[bold_post_a]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-4"];
			echo "&nbsp;&nbsp;";
			if(isset($style[1]) AND $style[1]) $checked="CHECKED"; else $checked="";
			echo "<INPUT type=checkbox name='PARAM[italic_post_a]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-5"];
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-6"] . " :</b>";
		echo "</TD><TD>";
			echo "<p class=atk_info>";
			if((!isset($style[2]) OR !$style[2]) AND (!isset($style[3]) OR !$style[3]) AND (!isset($style[4]) OR !$style[4])) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_post_a]' type=radio value=0 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-7"];
			echo "&nbsp;&nbsp;";
			if(isset($style[2]) AND $style[2]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_post_a]' type=radio value=1 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-8"];
			echo "&nbsp;&nbsp;";
			if(isset($style[3]) AND $style[3]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_post_a]' type=radio value=2 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-9"];
			echo "&nbsp;&nbsp;";
			if(isset($style[4]) AND $style[4]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_post_a]' type=radio value=3 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-10"];
		echo "</TD></TR>";
		echo "</TABLE>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-POLICE-10"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-1"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=22 name='PARAM[font_ssmenu]' value='" . $row["font_ssmenu"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-2"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=3 name='PARAM[size_ssmenu]' value='" . $row["size_ssmenu"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-3"] . " :</b>";
		echo "</TD><TD>";
			$style=strrev(decbin($row["style_ssmenu"]));
			echo "<p class=atk_info>";
			if(isset($style[0]) AND $style[0]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT type=checkbox name='PARAM[bold_ssmenu]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-4"];
			echo "&nbsp;&nbsp;";
			if(isset($style[1]) AND $style[1]) $checked="CHECKED"; else $checked="";
			echo "<INPUT type=checkbox name='PARAM[italic_ssmenu]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-5"];
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-6"] . " :</b>";
		echo "</TD><TD>";
			echo "<p class=atk_info>";
			if((!isset($style[2]) OR !$style[2]) AND (!isset($style[3]) OR !$style[3]) AND (!isset($style[4]) OR !$style[4])) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_ssmenu]' type=radio value=0 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-7"];
			echo "&nbsp;&nbsp;";
			if(isset($style[2]) AND $style[2]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_ssmenu]' type=radio value=1 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-8"];
			echo "&nbsp;&nbsp;";
			if(isset($style[3]) AND $style[3]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_ssmenu]' type=radio value=2 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-9"];
			echo "&nbsp;&nbsp;";
			if(isset($style[4]) AND $style[4]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_ssmenu]' type=radio value=3 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-10"];
		echo "</TD></TR>";
		echo "</TABLE>";
		
	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-POLICE-8"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-1"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=22 name='PARAM[font_link]' value='" . $row["font_link"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-2"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=3 name='PARAM[size_link]' value='" . $row["size_link"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-3"] . " :</b>";
		echo "</TD><TD>";
			$style=strrev(decbin($row["style_link"]));
			echo "<p class=atk_info>";
			if(isset($style[0]) AND $style[0]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT type=checkbox name='PARAM[bold_link]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-4"];
			echo "&nbsp;&nbsp;";
			if(isset($style[1]) AND $style[1]) $checked="CHECKED"; else $checked="";
			echo "<INPUT type=checkbox name='PARAM[italic_link]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-5"];
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-6"] . " :</b>";
		echo "</TD><TD>";
			echo "<p class=atk_info>";
			if((!isset($style[2]) OR !$style[2]) AND (!isset($style[3]) OR !$style[3]) AND (!isset($style[4]) OR !$style[4])) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_link]' type=radio value=0 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-7"];
			echo "&nbsp;&nbsp;";
			if(isset($style[2]) AND $style[2]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_link]' type=radio value=1 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-8"];
			echo "&nbsp;&nbsp;";
			if(isset($style[3]) AND $style[3]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_link]' type=radio value=2 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-9"];
			echo "&nbsp;&nbsp;";
			if(isset($style[4]) AND $style[4]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_link]' type=radio value=3 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-10"];
		echo "</TD></TR>";
		echo "</TABLE>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-POLICE-9"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-1"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=22 name='PARAM[font_link_a]' value='" . $row["font_link_a"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-2"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=3 name='PARAM[size_link_a]' value='" . $row["size_link_a"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-3"] . " :</b>";
		echo "</TD><TD>";
			$style=strrev(decbin($row["style_link_a"]));
			echo "<p class=atk_info>";
			if(isset($style[0]) AND $style[0]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT type=checkbox name='PARAM[bold_link_a]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-4"];
			echo "&nbsp;&nbsp;";
			if(isset($style[1]) AND $style[1]) $checked="CHECKED"; else $checked="";
			echo "<INPUT type=checkbox name='PARAM[italic_link_a]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-5"];
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-6"] . " :</b>";
		echo "</TD><TD>";
			echo "<p class=atk_info>";
			if((!isset($style[2]) OR !$style[2]) AND (!isset($style[3]) OR !$style[3]) AND (!isset($style[4]) OR !$style[4])) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_link_a]' type=radio value=0 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-7"];
			echo "&nbsp;&nbsp;";
			if(isset($style[2]) AND $style[2]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_link_a]' type=radio value=1 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-8"];
			echo "&nbsp;&nbsp;";
			if(isset($style[3]) AND $style[3]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_link_a]' type=radio value=2 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-9"];
			echo "&nbsp;&nbsp;";
			if(isset($style[4]) AND $style[4]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_link_a]' type=radio value=3 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-10"];
		echo "</TD></TR>";
		echo "</TABLE>";


	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-POLICE-11"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-1"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=22 name='PARAM[font_button_link]' value='" . $row["font_button_link"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-2"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=3 name='PARAM[size_button_link]' value='" . $row["size_button_link"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-3"] . " :</b>";
		echo "</TD><TD>";
			$style=strrev(decbin($row["style_button_link"]));
			echo "<p class=atk_info>";
			if(isset($style[0]) AND $style[0]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT type=checkbox name='PARAM[bold_button_link]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-4"];
			echo "&nbsp;&nbsp;";
			if(isset($style[1]) AND $style[1]) $checked="CHECKED"; else $checked="";
			echo "<INPUT type=checkbox name='PARAM[italic_button_link]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-5"];
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-6"] . " :</b>";
		echo "</TD><TD>";
			echo "<p class=atk_info>";
			if((!isset($style[2]) OR !$style[2]) AND (!isset($style[3]) OR !$style[3]) AND (!isset($style[4]) OR !$style[4])) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_button_link]' type=radio value=0 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-7"];
			echo "&nbsp;&nbsp;";
			if(isset($style[2]) AND $style[2]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_button_link]' type=radio value=1 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-8"];
			echo "&nbsp;&nbsp;";
			if(isset($style[3]) AND $style[3]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_button_link]' type=radio value=2 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-9"];
			echo "&nbsp;&nbsp;";
			if(isset($style[4]) AND $style[4]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_button_link]' type=radio value=3 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-10"];
		echo "</TD></TR>";
		echo "</TABLE>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-POLICE-12"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
		echo "<TABLE align=center cellspacing=0px>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-1"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=22 name='PARAM[font_button_link_a]' value='" . $row["font_button_link_a"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-2"] . " :</b>";
		echo "</TD><TD>";
			echo "<INPUT class=atk_input type=text size=3 name='PARAM[size_button_link_a]' value='" . $row["size_button_link_a"] . "'>";
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-3"] . " :</b>";
		echo "</TD><TD>";
			$style=strrev(decbin($row["style_button_link_a"]));
			echo "<p class=atk_info>";
			if(isset($style[0]) AND $style[0]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT type=checkbox name='PARAM[bold_button_link_a]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-4"];
			echo "&nbsp;&nbsp;";
			if(isset($style[1]) AND $style[1]) $checked="CHECKED"; else $checked="";
			echo "<INPUT type=checkbox name='PARAM[italic_button_link_a]' $checked value=1>";
			echo $LANG["ADMIN-OPTION-POLICE-5"];
		echo "</TD></TR>";
		echo "<TR><TD width=110px>";
			echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-POLICE-6"] . " :</b>";
		echo "</TD><TD>";
			echo "<p class=atk_info>";
			if((!isset($style[2]) OR !$style[2]) AND (!isset($style[3]) OR !$style[3]) AND (!isset($style[4]) OR !$style[4])) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_button_link_a]' type=radio value=0 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-7"];
			echo "&nbsp;&nbsp;";
			if(isset($style[2]) AND $style[2]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_button_link_a]' type=radio value=1 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-8"];
			echo "&nbsp;&nbsp;";
			if(isset($style[3]) AND $style[3]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_button_link_a]' type=radio value=2 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-9"];
			echo "&nbsp;&nbsp;";
			if(isset($style[4]) AND $style[4]) $checked="CHECKED"; else $checked="";
			echo "&nbsp;<INPUT name='PARAM[deco_button_link_a]' type=radio value=3 $checked>";
			echo $LANG["ADMIN-OPTION-POLICE-10"];
		echo "</TD></TR>";
		echo "</TABLE>";


	echo "<br>";

	echo "<center><INPUT type=submit value='" . $LANG["INPUT-OK"] . "'></center>";

	echo "</FORM>";
}

/*******************************************/
/* Affiche la rubrique de personnalisation */
/*******************************************/
function modify_perso($id){
	global $PHP_SELF, $LANG;

	// Rcupre les anciennes valeurs
	$query = "
		SELECT url_title, title, top_url, bottom_url, intro, subject,
		meta_title, meta_keywords, meta_description
		FROM atk_forums
		WHERE id=$id";
	$row = dbgetline($query);
	dbclose();

	echo "<p class=atk_title>" . $LANG["ADMIN-FORUMS-PERSO"] . ": " . $row["title"] . "<br>";
	echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id'>" . $LANG["ADMIN-FORUMS-RETURN-2"] . "</a></p>";

	echo "<FORM name=form method=post action='$PHP_SELF?action=rec_perso&id=$id&choix=3'>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-PERSO-1"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-PERSO-1"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[top_url]' value='" . $row["top_url"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-PERSO-2"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[bottom_url]' value='" . $row["bottom_url"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-PERSO-3"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[url_title]' value=\"" . $row["url_title"] . "\">";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-PERSO-4"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[title]' value=\"" . $row["title"] . "\">";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-PERSO-5"] . " :</b>";
	echo "</TD><TD>";
		echo "<TEXTAREA class=atk_input name='PARAM[intro]' cols=50 rows=3>";
		echo $row["intro"];
		echo "</TEXTAREA>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-PERSO-6"] . " :</b>";
	echo "</TD><TD>";
		echo "<TEXTAREA class=atk_input name='PARAM[subject]' cols=50 rows=3>";
		echo $row["subject"];
		echo "</TEXTAREA>";
	echo "</TD></TR>";
	echo "</TABLE>";

	echo "<br>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-PERSO-2"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
	
	echo "<TABLE align=center cellspacing=0px width=470px>";
	echo "<TR><TD width=170px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-PERSO-7"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[meta_title]' value=\"" . $row["meta_title"] . "\">";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-PERSO-8"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[meta_keywords]' value=\"" . $row["meta_keywords"] . "\">";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-PERSO-9"] . " :</b>";
	echo "</TD><TD>";
		echo "<TEXTAREA class=atk_input name='PARAM[meta_description]' cols=50 rows=3>";
		echo $row["meta_description"];
		echo "</TEXTAREA>";
	echo "</TD></TR>";
	echo "</TABLE>";
	
	echo "<BR>";
	
	echo "<center><INPUT type=submit value='" . $LANG["INPUT-OK"] . "'></center>";

	echo "</FORM>";
}

/*******************************/
/* affichage des autres options */
/*******************************/
function modify_other($id){
	global $PHP_SELF, $LANG;

	// Rcupre les anciennes valeurs
	$query = "SELECT * FROM atk_forums WHERE id=$id";
	$row = dbgetline($query);
	dbclose();

	echo "<p class=atk_title>" . $LANG["ADMIN-FORUMS-OTHER"] . ": " . $row["title"] . "<br>";
	echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id'>" . $LANG["ADMIN-FORUMS-RETURN-2"] . "</a></p>";

     echo "<p align=center><TABLE>";
	echo "<TR><TD bgcolor=#FFEECC>";
		echo "<p class=atk_info align=center>" . $LANG["ADMIN-COLORS-ORANGE"];
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#AAEEBB>";
		echo "<p class=atk_info align=center>" . $LANG["ADMIN-COLORS-GREEN"];
	echo "</TD></TR>";
	echo "</TABLE>";

	echo "<FORM name=form method=post action='$PHP_SELF?action=rec_other&id=$id&choix=3'>";
	echo "<center><INPUT type=submit value='" . $LANG["INPUT-OK"] . "'></center>";

	/**********************/
	/* Structure du forum */
	/**********************/
	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-OTHER-7"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px width=80%>";
	echo "<TR><TD width=250px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-2"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=6 name='PARAM[width]' value='" . $row["width"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-14"] . " :</b>";
	echo "</TD><TD>";
		echo "<p class=atk_info>&nbsp;";
		if($row["structure"]) $checked="checked"; else $checked="";
		echo "<INPUT type=radio name='PARAM[structure]' value=1 $checked> ";
		echo $LANG["ADMIN-OPTION-ADVANCED-14-CHOOSE-1"];
		echo "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
		if($row["structure"]) $checked=""; else $checked="checked";
		echo "<INPUT type=radio name='PARAM[structure]' value=0 $checked> ";
		echo $LANG["ADMIN-OPTION-ADVANCED-14-CHOOSE-2"];
		echo "<BR>&nbsp;";
		if($row["structure"]==2) $checked="checked"; else $checked="";
		echo "<INPUT type=radio name='PARAM[structure]' value=2 $checked> ";
		echo $LANG["ADMIN-OPTION-ADVANCED-14-CHOOSE-3"];
		if($row["structure"]==3) $checked="checked"; else $checked="";
		echo "<INPUT type=radio name='PARAM[structure]' value=3 $checked> ";
		echo $LANG["ADMIN-OPTION-ADVANCED-14-CHOOSE-4"];
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-15"] . " :</b>";
	echo "</TD><TD>";
		if($row["avatar"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[avatar]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-16"] . " :</b>";
	echo "</TD><TD>";
		if($row["edit"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[edit]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-17"] . " :</b>";
	echo "</TD><TD>";
		if($row["incrementation"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[incrementation]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-24"] . " :</b>";
	echo "</TD><TD>";
		if($row["up_subject"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[up_subject]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#AAEEBB>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-18"] . " :</b>";
	echo "</TD><TD>";
		echo "<p class=atk_info>&nbsp;";
		if($row["arbo"]==0) $option="checked"; else $option="";
		echo "<INPUT type=radio name='PARAM[arbo]' value='0' $option> " . $LANG["ADMIN-OPTION-ADVANCED-18-CHOOSE-1"];
		if($row["arbo"]==1) $option="checked"; else $option="";
		echo "<INPUT type=radio name='PARAM[arbo]' value='1' $option> " . $LANG["ADMIN-OPTION-ADVANCED-18-CHOOSE-2"];
		if($row["arbo"]==2) $option="checked"; else $option="";
		echo "<INPUT type=radio name='PARAM[arbo]' value='2' $option> " . $LANG["ADMIN-OPTION-ADVANCED-18-CHOOSE-3"];
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-20"] . " :</b>";
	echo "</TD><TD>";
		echo "<p class=atk_info>&nbsp;";
		if($row["fast_view"]==0) $option="checked"; else $option="";
		echo "<INPUT type=radio name='PARAM[fast_view]' value='0' $option> " . $LANG["ADMIN-OPTION-ADVANCED-20-CHOOSE-1"] . "<BR>";
		if($row["fast_view"]==1) $option="checked"; else $option="";
		echo "&nbsp;<INPUT type=radio name='PARAM[fast_view]' value='1' $option> " . $LANG["ADMIN-OPTION-ADVANCED-20-CHOOSE-2"] . "<BR>";
		if($row["fast_view"]==2) $option="checked"; else $option="";
		echo "&nbsp;<INPUT type=radio name='PARAM[fast_view]' value='2' $option> " . $LANG["ADMIN-OPTION-ADVANCED-20-CHOOSE-3"];
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-34"] . " :</b>";
	echo "</TD><TD>";
		echo "<p class=atk_info>&nbsp;";
		if($row["poll"]==0) $option="checked"; else $option="";
		echo "<INPUT type=radio name='PARAM[poll]' value='0' $option> " . $LANG["ADMIN-OPTION-ADVANCED-34-CHOOSE-1"];
		if($row["poll"]==1) $option="checked"; else $option="";
		echo "<INPUT type=radio name='PARAM[poll]' value='1' $option> " . $LANG["ADMIN-OPTION-ADVANCED-34-CHOOSE-2"];
		if($row["poll"]==2) $option="checked"; else $option="";
		echo "<INPUT type=radio name='PARAM[poll]' value='2' $option> " . $LANG["ADMIN-OPTION-ADVANCED-34-CHOOSE-3"];
	echo "</TD></TR>";
	echo "</TABLE>";

    /*********************/
	/* Paramtres locaux */
	/*********************/	
	echo "<BR><p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-OTHER-8"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
	
	echo "<TABLE align=center cellspacing=0px width=80%>";	
	echo "<TR><TD width=250px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-9"] . " :</b>";
	echo "</TD><TD>";
		echo "<SELECT class=atk_input name='PARAM[language]'>";
			// Recherche des fichiers ALF (Aztek Language File)
			$rep = opendir("./lang/");
			while($file=readdir($rep)){
				if($file != "." && $file != ".." && is_dir("./lang/" . $file)){
					$f=fopen("./lang/$file/$file.php","r");
					$k=fgets($f,1024);
					if(substr($k,0,25)=="<? // Aztek Language File"){
						if($file==$row["language"]) $option="selected"; else $option="";
						echo "<OPTION value='$file' $option>$file</OPTION>";
					}
					fclose($f);
				}
			}
			closedir($rep);
		echo "</SELECT>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-10"] . " :</b>";
	echo "</TD><TD>";
		echo "<SELECT class=atk_input name='PARAM[local_time]'>";
			for($i=-12;$i<13;$i++){
				if($row["local_time"]==$i) $selected="SELECTED"; else $selected="";
				if($i>=0) $time = "+" . $i; else $time=$i;
				echo "<OPTION value=$i $selected>$time</OPTION>";
			}
		echo "</SELECT>";
	echo "</TD></TR>";
	echo "</TABLE>";
	
	echo "<p class=atk_info align=center><BR>" . $LANG["ADMIN-FORUMS-OTHER-2"];	

    /***************************/
	/* Paramtres d'affichages */
	/***************************/	
	echo "<BR><p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-OTHER-9"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";
	
	echo "<TABLE align=center cellspacing=0px width=80%>";
	echo "<TR><TD width=250px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-3"] . " :</b>";
	echo "</TD><TD>";
		if($row["fade_link"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[fade_link]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-4"] . " :</b>";
	echo "</TD><TD>";
		if($row["fade_icon"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[fade_icon]' value='1' $option>";
	echo "</TD></TR>";	
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-5"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=6 name='PARAM[nb_subjects_per_page]' value='" . $row["nb_subjects_per_page"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-6"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=6 name='PARAM[nb_posts_per_page]' value='" . $row["nb_posts_per_page"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-7"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=6 name='PARAM[nb_members_per_page]' value='" . $row["nb_members_per_page"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD bgcolor=#FFEECC>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-8"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=6 name='PARAM[nb_folder_fire]' value='" . $row["nb_folder_fire"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-25"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT type=hidden name='PARAM[tags_flag]' value=1>";
		echo "<p class=atk_info>&nbsp;";
		$tags=strrev(decbin($row["tags"]));
		if(isset($tags[0]) AND $tags[0]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_0]' value=0 $checked> " . $LANG["TAG-IMG"];
		if(isset($tags[1]) AND $tags[1]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_1]' value=1 $checked> " . $LANG["TAG-CIT"];
		if(isset($tags[2]) AND $tags[2]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_2]' value=2 $checked> " . $LANG["TAG-BOLD"];
		if(isset($tags[3]) AND $tags[3]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_3]' value=3 $checked> " . $LANG["TAG-ITALIC"];
		echo "<BR>&nbsp;";
		if(isset($tags[4]) AND $tags[4]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_4]' value=4 $checked> " . $LANG["TAG-UNDERLINE"];
		if(isset($tags[5]) AND $tags[5]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_5]' value=5 $checked> " . $LANG["TAG-STRIKE"];
		if(isset($tags[6]) AND $tags[6]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_6]' value=2 $checked> " . $LANG["TAG-SUPERSCRIPT"];
		if(isset($tags[7]) AND $tags[7]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_7]' value=3 $checked> " . $LANG["TAG-SUBSCRIPT"];
		echo "<BR>&nbsp;";
		if(isset($tags[8]) AND $tags[8]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_8]' value=4 $checked> " . $LANG["TAG-BIG"];
		if(isset($tags[9]) AND $tags[9]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_9]' value=5 $checked> " . $LANG["TAG-SMALL"];
		if(isset($tags[10]) AND $tags[10]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_10]' value=2 $checked> " . $LANG["TAG-CODE"];
		echo "<BR>&nbsp;";
		if(isset($tags[11]) AND $tags[11]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_11]' value=4 $checked> " . $LANG["TAG-WHITE"];
		if(isset($tags[12]) AND $tags[12]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_12]' value=5 $checked> " . $LANG["TAG-BLACK"];
		if(isset($tags[13]) AND $tags[13]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_13]' value=2 $checked> " . $LANG["TAG-YELLOW"];
		if(isset($tags[14]) AND $tags[14]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_14]' value=3 $checked> " . $LANG["TAG-ORANGE"];
		echo "<BR>&nbsp;";
		if(isset($tags[15]) AND $tags[15]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_15]' value=4 $checked> " . $LANG["TAG-RED"];
		if(isset($tags[16]) AND $tags[16]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_16]' value=5 $checked> " . $LANG["TAG-PURPLE"];
		if(isset($tags[17]) AND $tags[17]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_17]' value=2 $checked> " . $LANG["TAG-BLUE"];
		if(isset($tags[18]) AND $tags[18]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_18]' value=3 $checked> " . $LANG["TAG-GREEN"];
		echo "<BR>&nbsp;";
		if(isset($tags[19]) AND $tags[19]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[tags_19]' value=4 $checked> " . $LANG["TAG-FLASH"];
		echo "<BR><BR>";	
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-27"] . " :</b>";
	echo "</TD><TD>";
		echo "<TEXTAREA class=atk_input name='PARAM[status]' rows=3 cols=30>" . $row["status"] . "</TEXTAREA>";	
	echo "</TD></TR>";	
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-28"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text name='PARAM[max_status]' value='" . $row["max_status"] . "' size=6>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-31"] . " :</b>";
	echo "</TD><TD>";
		if($row["show_stat"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[show_stat]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-38"] . " :</b>";
	echo "</TD><TD>";
		if($row["show_connected"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[show_connected]' value='1' $option>";
	echo "</TD></TR>";		
	echo "<TR><TD bgcolor=#FFEECC>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-32"] . " :</b>";
	echo "</TD><TD>";
		if($row["show_ssmenu"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[show_ssmenu]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-35"] . " :</b>";
	echo "</TD><TD>";
		if($row["dynamic_poll"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[dynamic_poll]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-37"] . " :</b>";
	echo "</TD><TD>";
		if($row["edit_alert"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[edit_alert]' value='1' $option>";
	echo "</TD></TR>";		
	echo "</TABLE>";

    /*******************/
	/* Options en vrac */
	/*******************/
	echo "<BR><p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-OTHER-1"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px width=80%>";
	echo "<TR><TD width=250px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-1"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text name='PARAM[return_path]' size=30 value='" . $row["return_path"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-1-INDEX"] . " :</b>";
	echo "</TD><TD>";
		if($row["return_index"]) $option="checked"; else $option="";
		echo "<INPUT class=atk_input type=checkbox name='PARAM[return_index]' $option value='1'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-11"] . " :</b>";
	echo "</TD><TD>";
		if($row["log"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[log]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-39"] . " :</b>";
	echo "</TD><TD>";
		if($row["log_forum"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[log_forum]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-40"] . " :</b>";
	echo "</TD><TD>";
		echo "<TEXTAREA class=atk_input name='PARAM[log_login]' rows=3 cols=30>" . $row["log_login"] . "</TEXTAREA>";	
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-36"] . " :</b>";
	echo "</TD><TD>";
		if($row["free_login"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[free_login]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-12"] . " :</b>";
	echo "</TD><TD>";
		if($row["html"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[html]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-13"] . " :</b>";
	echo "</TD><TD>";
		echo "<TEXTAREA class=atk_input name='PARAM[other_profile]' rows=3 cols=30>" . $row["other_profile"] . "</TEXTAREA>";	
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-26"] . " :</b>";
	echo "</TD><TD>";
		if($row["comment"]) $option="checked"; else $option="";	
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[comment]' value='1' $option>";
	echo "</TD></TR>";	
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-33"] . " :</b>";
	echo "</TD><TD>";
		if($row["upload"]) $option="checked"; else $option="";	
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[upload]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-41"] . " :</b>";
	echo "</TD><TD>";
		if($row["infos_perso"]) $option="checked"; else $option="";	
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[infos_perso]' value='1' $option>";
	echo "</TD></TR>";	
	echo "</TABLE>";

	/*****************/
	/* Barre de menu */
	/*****************/
	echo "<BR><p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-OTHER-6"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-21"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT type=hidden name='PARAM[icon_flag]' value=1>";
		echo "<p class=atk_info>&nbsp;";
		$menu_icon=strrev(decbin($row["icon"]));
		if(isset($menu_icon[6]) AND $menu_icon[6]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[icon_6]' value=6 $checked> " . $LANG["ADMIN-OPTION-ADVANCED-21-CHOOSE-7"];		
		if(isset($menu_icon[0]) AND $menu_icon[0]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[icon_0]' value=0 $checked> " . $LANG["ADMIN-OPTION-ADVANCED-21-CHOOSE-1"];
		if(isset($menu_icon[1]) AND $menu_icon[1]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[icon_1]' value=1 $checked> " . $LANG["ADMIN-OPTION-ADVANCED-21-CHOOSE-2"];
		if(isset($menu_icon[2]) AND $menu_icon[2]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[icon_2]' value=2 $checked> " . $LANG["ADMIN-OPTION-ADVANCED-21-CHOOSE-3"];
		echo "<br>&nbsp;";
		if(isset($menu_icon[3]) AND $menu_icon[3]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[icon_3]' value=3 $checked> " . $LANG["ADMIN-OPTION-ADVANCED-21-CHOOSE-4"];
		if(isset($menu_icon[4]) AND $menu_icon[4]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[icon_4]' value=4 $checked> " . $LANG["ADMIN-OPTION-ADVANCED-21-CHOOSE-5"];
		if(isset($menu_icon[5]) AND $menu_icon[5]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[icon_5]' value=5 $checked> " . $LANG["ADMIN-OPTION-ADVANCED-21-CHOOSE-6"];
		if(isset($menu_icon[7]) AND $menu_icon[7]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[icon_7]' value=7 $checked> " . $LANG["ADMIN-OPTION-ADVANCED-21-CHOOSE-8"];
		echo "<br>&nbsp;";
		if(isset($menu_icon[8]) AND $menu_icon[8]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[icon_8]' value=3 $checked> " . $LANG["ADMIN-OPTION-ADVANCED-21-CHOOSE-9"];

	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-22"] . " :</b>";
	echo "</TD><TD>";
		echo "<p class=atk_info>&nbsp;";
		if($row["dblmenu"]) $checked="CHECKED"; else $checked="";
		echo "<INPUT type=checkbox name='PARAM[dblmenu]' value=1 $checked>";
	echo "</TD></TR>";
	echo "</TABLE>";

	/***********************/
	/* Gestion des smileys */
	/***********************/
	echo "<BR><p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-OTHER-3"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px width=80%>";
	echo "<TR><TD width=250px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-23"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=2 name='PARAM[nb_smiley]' value='" . $row["nb_smiley"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-19"] . " :</b>";
	echo "</TD><TD>";
		if($row["global_smiley"]) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[global_smiley]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-ADVANCED-30"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[smiley_path]' value='" . $row["smiley_path"] . "'>";
	echo "</TD></TR>";
	echo "</TABLE>";

	echo "<br>";

	echo "<p class=atk_info align=center>" . $LANG["ADMIN-FORUMS-OTHER-4"];

	echo "<br><br>";

	echo "<center><INPUT type=submit value='" . $LANG["INPUT-OK"] . "'></center>";

	echo "</FORM>";
}

/*************************************************/
/* affiche la rubrique de paramtrage des emails */
/*************************************************/
function modify_email($id){
	global $PHP_SELF, $LANG;

	// Rcupre les anciennes valeurs
	$query = "SELECT title,mail_actived,return_mail,alert_mail FROM atk_forums WHERE id=$id";
	$row = dbgetline($query);
	dbclose();

	echo "<p class=atk_title>" . $LANG["ADMIN-FORUMS-MAIL"] . ": " . $row["title"] . "<br>";
	echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id'>" . $LANG["ADMIN-FORUMS-RETURN-2"] . "</a></p>";

	echo "<FORM name=form method=post action='$PHP_SELF?action=rec_mail&id=$id&choix=3'>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-MAIL-1"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-MAIL-1"] . "</b>";
	echo "</TD><TD>";
		if($row["mail_actived"]==1) $option="checked"; else $option="";
		echo "<p class=atk_info>&nbsp;<INPUT type=checkbox name='PARAM[mail_actived]' value='1' $option>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-MAIL-2"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[return_mail]' value='" . $row["return_mail"] . "'>";
	echo "</TD></TR>";
	echo "<TR><TD>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-MAIL-3"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=30 name='PARAM[alert_mail]' value='" . $row["alert_mail"] . "'>";
	echo "</TD></TR>";
	echo "</TABLE>";

	echo "<br>";

	echo "<center><INPUT type=submit value='" . $LANG["INPUT-OK"] . "'></center>";
	echo "<p class=atk_info align=justify>" . $LANG["ADMIN-OPTION-MAIL-INFO"] . "</p>";
	echo "</FORM>";
}


/**********************************/
/* Modification du password forum */
/**********************************/
function modify_passwd($id){
	global $PHP_SELF, $LANG;

	// Rcupre les anciennes valeurs
	$query = "SELECT title FROM atk_forums WHERE id=$id";
	$row = dbgetline($query);
	dbclose();

	echo "<p class=atk_title>" . $LANG["ADMIN-FORUMS-OTHER"] . ": " . $row["title"] . "<br>";
	echo "<a class=atk_lien href='$PHP_SELF?choix=3&id=$id'>" . $LANG["ADMIN-FORUMS-RETURN-2"] . "</a></p>";

	echo "<FORM name=form method=post action='$PHP_SELF?action=rec_passwd&id=$id&choix=3'>";

	echo "<p class=atk_info align=left><b>" . $LANG["ADMIN-FORUMS-OTHER-5"] . "</b>";
	echo "<br><img src='images/barre.jpg'><br><br>";

	echo "<TABLE align=center cellspacing=0px>";
	echo "<TR><TD width=180px>";
		echo "<p class=atk_info><b>" . $LANG["ADMIN-OPTION-PASSWD-1"] . " :</b>";
	echo "</TD><TD>";
		echo "<INPUT class=atk_input type=text size=14 name='PARAM[passwd]'>";
	echo "</TD></TR>";
	echo "</TABLE>";

	echo "<br>";

	echo "<center><INPUT type=submit value='" . $LANG["INPUT-OK"] . "'></center>";

	echo "</FORM>";
}
?>
