<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

/*****************************************************************/
/* Gestion des sessions. Sortie: $user, $droit et $LAST_VISIT	 */
/* Pas de session pour les Invit(e)s							 */
/*****************************************************************/

// Utilisation des sessions php
if($PHP_SESS_ENABLED){

	/************************/
	/* Gestion des sessions */
	/************************/
	session_name('ATKSESSID');
	session_start();
	
	// Initialisation des login rels de la session
	if(empty($_SESSION["SESS_LOGIN"])){
		$_SESSION["SESS_LOGIN"]="nobody";
		$_SESSION["SESS_PASSWD"]="";
	}
	
	// Donne les valeurs aux varables globales
	$ATK_LOGIN = $_SESSION["SESS_LOGIN"];
	$ATK_PASSWD = $_SESSION["SESS_PASSWD"];
	
	// Recherche un ventuel ID de session
	if(isset($_SESSION["SESS_ID"][0])) $ID_SESS = $_SESSION["SESS_ID"][0];
	else $ID_SESS="";
	
	// Initialise les droits
	$DROIT = 0;
	
	/***********************************************/
	/* La session existe dj, reconnait le membre */
	/***********************************************/
	if(!empty($ID_SESS)){
	
		// Connexion  la base de donnes
		dbconnect();
		
		// Une session existe, rcupre les enregistrements
		$query = "
			SELECT atk_sessions.user, atk_sessions.droit
			FROM atk_sessions
			WHERE id='$ID_SESS' AND forum=0 AND expire >= $DATE";
		$sql = dbquery($query);
	
		// Vrification de l'existence de la session
		// + vrification d'un log sur $SESS_LOGIN global
		if(!$row=mysql_fetch_array($sql)){
	
			// Session inexistante dans la table sessions (session expir par ex.)
			$ID_SESS="";
			// Supprime la session
			$_SESSION['SESS_ID'][0] = "";
	
		} else {
	
			// Rcupre les donnes de la session
			$ATK_LOGIN = $row["user"];
			$DROIT = $row["droit"];
			$PRIV=strrev(decbin($DROIT));
	
			// Met  jour la date d'expiration de la session
			$query = "
				UPDATE atk_sessions
				SET expire = $SESSION_EXPIRE
				WHERE id = '$ID_SESS' AND forum = 0";
			dbquery($query);
	
		}
	
	}

// Utilisation des sessions "maison"
} else {
	
	/* Les privigges sont  zro au dpart
	/********************************************/
	$DROIT=0;
	
	/* Un cookie de session existe, reconnait le membre
	/***************************************************/
	if($ID_SESS){
		// Une session existe, rcupre les enregistrement
		$query = "
			SELECT user, droit
			FROM atk_sessions
			WHERE forum=0 AND id='$ID_SESS'";
		$sql = dbquery($query);
	
		if(!$row=mysql_fetch_array($sql)){
	
			// Session inexistante dans la table sessions (session expir par ex.)
			$ID_SESS="";
			// Supprime le cookie de session
			setcookie("ATK_ADMIN");
	
		} else {
	
			// Rcupre les donnes de la session
			$ATK_LOGIN=$row["user"];
			$DROIT=$row["droit"];
			$PRIV=strrev(decbin($DROIT));
			// Met  jour la date d'expiration de la session
			$query = "
				UPDATE atk_sessions
				SET expire=$SESSION_EXPIRE
				WHERE id='$ID_SESS' AND forum=0";
			dbquery($query);
	
		}
	}
	
}
?>