<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

/******************************/
/* Affichage des statistiques */
/******************************/
function show_stat($order){
	global $LANG, $PHP_SELF, $PRIV, $DROIT, $ATK_LOGIN, $BY_ID;

	if(empty($order)) $order="id";
	
	// Si administrateur systme
	if(!empty($PRIV[1]) || !empty($PRIV[4])){

		// Compte le nombre total des visites
		$n_visit=dbgetfirst("SELECT sum(nb_visit) FROM atk_forums");
		// Compte le nombre total de posts
		$n_post=dbgetfirst("SELECT COUNT(*) FROM atk_posts");

		// Requte Gnrale
		$query = "
			SELECT COUNT(atk_posts.id) AS NUMBER, atk_forums.id, atk_forums.owner,
			atk_forums.title, atk_forums.date, atk_forums.nb_visit,
			atk_forums.filename, atk_forums.locked, atk_forums.hidden, atk_admin.droit
			FROM atk_forums
			LEFT OUTER JOIN atk_posts
			ON atk_forums.id = atk_posts.forum
			LEFT OUTER JOIN atk_admin
			ON atk_admin.forum = atk_forums.id
			AND atk_admin.login = '$ATK_LOGIN'
			GROUP BY atk_forums.id
			ORDER BY $order";
		$sql = dbquery($query);

	// L'administrateur est administrateur sur certain forums seulement
	} else {

		// Compte le nombre total des visites
		$query = "
			SELECT sum(nb_visit)
			FROM atk_forums, atk_admin
			WHERE atk_admin.forum = atk_forums.id
			AND atk_admin.login='$ATK_LOGIN'";
		$n_visit=dbgetfirst($query);
		// Compte le nombre total de posts
		$query = "
			SELECT COUNT(*)
			FROM atk_posts, atk_admin
			WHERE atk_admin.forum = atk_posts.forum
			AND atk_admin.login = '$ATK_LOGIN'";
		$n_post=dbgetfirst($query);

		// Requte Gnrale
		$query = "
			SELECT COUNT(atk_posts.id) AS NUMBER, atk_forums.id, atk_forums.owner,
			atk_forums.title, atk_forums.date, atk_forums.nb_visit,
			atk_forums.filename, atk_forums.locked, atk_admin.droit
			FROM atk_admin, atk_forums
			LEFT OUTER JOIN atk_posts
			ON atk_forums.id=atk_posts.forum
			WHERE atk_admin.forum = atk_forums.id
			AND atk_admin.login = '$ATK_LOGIN'
			GROUP BY atk_forums.id
			ORDER BY $order";
		$sql = dbquery($query);

	}

	// Affichage du titre
	echo "<p class=atk_title>" . $LANG["ADMIN-STAT-TITLE"] . "</p>";

	echo "<TABLE align=center bordercolor='#CCCCFF' bgcolor='#CCCCFF' cellspacing=1px style='border-width: 1px; border-style: solid;'>";

		echo "<TR><TD width=18px bgcolor=#DDEEFF height=16px>";
			echo "<p class=atk_info align=center><A href='$PHP_SELF?choix=1&order=id'>" . $LANG["ADMIN-STAT-1"] . "</A>";
		echo "</TD><TD width=180px bgcolor=#DDEEFF height=16px>";
			echo "<p class=atk_info align=center><A href='$PHP_SELF?choix=1&order=title'>" . $LANG["ADMIN-STAT-2"] . "</A>";
		echo "</TD><TD width=90px bgcolor=#DDEEFF height=16px>";
			echo "<p class=atk_info align=center><A href='$PHP_SELF?choix=1&order=owner'>" . $LANG["ADMIN-STAT-6"] . "</A>";
		echo "</TD><TD width=140px bgcolor=#DDEEFF height=16px>";
			echo "<p class=atk_info align=center><A href='$PHP_SELF?choix=1&order=id'>" . $LANG["ADMIN-STAT-3"] . "</A>";
		echo "</TD><TD width=50px bgcolor=#DDEEFF height=16px>";
			echo "<p class=atk_info align=center><A href='$PHP_SELF?choix=1&order=nb_visit'>" . $LANG["ADMIN-STAT-4"] . "</A>";
		echo "</TD><TD width=40px bgcolor=#DDEEFF height=16px>";
			echo "<p class=atk_info align=center><A href='$PHP_SELF?choix=1&order=nb_visit'>%</A>";
		echo "</TD><TD width=50px bgcolor=#DDEEFF height=16px>";
			echo "<p class=atk_info align=center><A href='$PHP_SELF?choix=1&order=NUMBER'>" . $LANG["ADMIN-STAT-5"] . "</A>";
		echo "</TD><TD width=40px bgcolor=#DDEEFF height=16px>";
			echo "<p class=atk_info align=center><A href='$PHP_SELF?choix=1&order=NUMBER'>%</A>";
		echo "</TD><TD width=50px bgcolor=#DDEEFF height=16px>";
			echo "&nbsp;";
		echo "</TD></TR>";

		while($row=mysql_fetch_array($sql)){

			if($row["owner"] == $ATK_LOGIN) $color="#FFEEDD";
			else $color="#FFFFFF";

			echo "<TR><TD bgcolor=$color height=20px>";
				echo "<p class=atk_info align=center>" . $row["id"];
			echo "</TD><TD bgcolor=$color height=20px>";
				if($BY_ID)  echo "<center><a href='./forum.php?fid=" . $row["id"] . "' target='_blank'>" . $row["title"] . "</a></center>";
				else echo "<center><a href='" . $row["filename"] . "' target='_blank'>" . $row["title"] . "</a></center>";
			echo "</TD><TD bgcolor=$color height=20px>";
				echo "<p class=atk_info align=center>" . $row["owner"];
			echo "</TD><TD bgcolor=$color height=20px>";
				echo "<p class=atk_info align=center>" . date($LANG["FORMAT-DATE"],$row["date"]);
			echo "</TD><TD bgcolor=$color height=20px>";
				echo "<p class=atk_info align=center>" . $row["nb_visit"];
			echo "</TD><TD bgcolor=$color height=20px>";
				if($n_visit>0) echo "<p class=atk_info align=center>" . floor($row["nb_visit"]*1000/$n_visit)/10 . "%";
				else  echo "<p class=atk_info align=center>0%";
			echo "</TD><TD bgcolor=$color height=20px>";
				echo "<p class=atk_info align=center>" . $row[0];
			echo "</TD><TD bgcolor=$color height=20px>";
				if($n_post>0) echo "<p class=atk_info align=center>" . floor($row[0]*1000/$n_post)/10 . "%";
				else echo "<p class=atk_info align=center>0%";
			echo "</TD><TD bgcolor=#FFEEDD height=20px align=center>";
				// Vrifie les droits de suppression d'un forum
				if($row["droit"]) $priv=strrev(decbin($row["droit"]));
				else $priv=0;
				if(!empty($PRIV[1]) OR !empty($priv[4])){
					echo "<a href='$PHP_SELF?choix=10&return=1&idel=" . $row["id"] . "'><img src='images/delete.gif' border=0 alt='" . $LANG["ADMIN-STAT-DEL-TIP"] . "' title='" . $LANG["ADMIN-STAT-DEL-TIP"] . "' hspace=2></a>";
				}
				if(!empty($PRIV[4]) OR !empty($priv[0])){
					if(empty($row["locked"])) echo "<a href='$PHP_SELF?choix=1&action=lock_forum&id=" . $row["id"] . "'><img src='images/lock.gif' border=0 alt='" . $LANG["ADMIN-STAT-LOCK-TIP"] . "' TITLE='" . $LANG["ADMIN-STAT-LOCK-TIP"] . "' hspace=2></a>";
					else echo "<a href='$PHP_SELF?choix=1&action=lock_forum&id=" . $row["id"] . "'><img src='images/unlock.gif' border=0 alt='" . $LANG["ADMIN-STAT-UNLOCK-TIP"] . "' TITLE='" . $LANG["ADMIN-STAT-UNLOCK-TIP"] . "' hspace=2></a>";
				
					if(empty($row["hidden"])) echo "<a href='$PHP_SELF?choix=1&action=hide_forum&id=" . $row["id"] . "'><img src='images/hide.gif' border=0 alt='" . $LANG["ADMIN-STAT-HIDE-TIP"] . "' TITLE='" . $LANG["ADMIN-STAT-HIDE-TIP"] . "' hspace=2></a>";
					else echo "<a href='$PHP_SELF?choix=1&action=hide_forum&id=" . $row["id"] . "'><img src='images/show.gif' border=0 alt='" . $LANG["ADMIN-STAT-SHOW-TIP"] . "' TITLE='" . $LANG["ADMIN-STAT-SHOW-TIP"] . "' hspace=2></a>";
				}
				if(empty($PRIV[1]) && empty($priv[4]) && empty($PRIV[4]) && empty($priv[0])) echo "&nbsp;";
			echo "</TD></TR>";

		}
		dbclose();

		echo "<TR><TD width=18px bgcolor=#DDEEFF height=20px>";
			echo "&nbsp;";
		echo "</TD><TD width=200px bgcolor=#DDEEFF height=20px>";
			echo "&nbsp;";
		echo "</TD><TD width=100px bgcolor=#DDEEFF height=20px>";
			echo "&nbsp;";
		echo "</TD><TD width=120px bgcolor=#DDEEFF height=20px>";
			echo "&nbsp;";
		echo "</TD><TD width=50px bgcolor=#DDEEFF height=20px>";
			echo "<p class=atk_info align=center>" . $n_visit;
		echo "</TD><TD width=40px bgcolor=#DDEEFF height=20px>";
			echo "<p class=atk_info align=center>100%";
		echo "</TD><TD width=50px bgcolor=#DDEEFF height=20px>";
			echo "<p class=atk_info align=center>" . $n_post;
		echo "</TD><TD width=40px bgcolor=#DDEEFF height=20px>";
			echo "<p class=atk_info align=center>100%";
		echo "</TD><TD width=14px bgcolor=#DDEEFF height=20px>";
			echo "&nbsp;";
		echo "</TD></TR>";

	echo "</TABLE>";

	echo "<p class=atk_info align=center>" . $LANG["ADMIN-STAT-INFO"];

}
?>
