<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

/***************************************/
/* Fonction gnrale de redistribution */
/***************************************/
function inbox($read, $option, $recipient, $title, $text){
	global $LANG, $ATK_LOGIN;

	// Si l'utilisateur n'est pas logu, il sort
	if($ATK_LOGIN == "nobody") exit;

	// Lecture d'un post
	if($read) print_msg($read);
	// On veux envoyer un nouveau message
	if($option == "write") print_write($recipient, $title, $text);
	elseif($option == "send") print_send();
	else print_inbox();
}

/*********************************/
/* Affiche la liste des messages */
/*********************************/
function print_inbox(){
	global $LANG, $ATK_LOGIN, $MYSELF, $PF, $CONNECTED_FORUM_USER, $CONNECTED_INDEX_USER;

	// On rcupre tous les messages
	$query="
		SELECT atk_inbox.*, atk_users.email, atk_users.show_email
		FROM atk_inbox, atk_users
		WHERE recipient='$ATK_LOGIN'
		AND atk_inbox.sender = atk_users.login
		AND atk_inbox.deleted_done <> 1
		ORDER BY date DESC";
	$sql=dbquery($query);

	// Affichage del'entte de la messagerie
	echo "<BR><TABLE class=atk_default width=100% cellspacing=0 cellpadding=0>";
	echo "<TR><TD class=atk_title colspan=5>";

		// Affichage de l'entete de la rubrique courante
		echo "<TABLE width=100% cellspacing=0 cellpadding=0><TR>";
		echo "<TD class=atk_menu width=36px align=left>";
			echo "<INPUT type=checkbox name='noname' onclick='CheckboxControl()'>";
		echo "</TD>";
		echo "<TD class=atk_menu width=36px align=center>";
		echo "</TD>";		
		echo "<TD align=center>";
			echo "<p class=atk_menu><b>" . $LANG["INBOX-COL-2"] . "</b>";
		echo "</TD>";
		echo "<TD class=atk_body width=130px align=center>";
			echo "<p class=atk_menu><b>" . $LANG["INBOX-COL-3"] . "</b>";
		echo "</TD>";
		echo "<TD class=atk_body width=110px align=center>";
          	echo "<p class=atk_menu><b>" . $LANG["INBOX-COL-4"] . "</b>";
		echo "</TD>";
		echo "</TR></TABLE>";

	echo "</TD></TR>";

	// Gestion des CheckBox en javascript
	echo "<SCRIPT language='JavaScript' src='javascript/CheckBox.js' type='text/javascript'></SCRIPT>";

	// Gestion de la surbrillance
	if($PF["bg_highlight"] || $PF["bg_onclick"]){
		include("./javascript/highlight.js");
		$highlight = "onClick=\"setRowColor(this, '" . $PF["bg_onclick"] . "', 'click')\" onMouseOver=\"setRowColor(this, '" . $PF["bg_highlight"] . "', 'over')\" onMouseOut=\"setRowColor(this, '', 'out')\"";
	} else $highlight="";
	$count=0;
	
	echo "<form name=form method='post' action='" . $MYSELF . "choix=11&action=inbox_del'>";

	$color=""; $bg_img="";
	while($row=mysql_fetch_array($sql)){
		$count++;
	
	     if(!isset($flag)) $flag=1;
	     
	     if($row["deleted"] == 1 || $row["deleted"] == 3) $row["deleted"] = 1;
	     else $row["deleted"] = 0;

		/******************************************/
		/* Affichage d'un message dans le tableau */
		/******************************************/
		// Alternance des couleurs
		if($color==$PF["bg_line_1"]) $color=$PF["bg_line_2"]; else $color=$PF["bg_line_1"];
		if($bg_img==$PF["img_line_1"]) $bg_img=$PF["img_line_2"]; else $bg_img=$PF["img_line_1"];
		// Recherche l'image du dossier
		if($row["seen"]) $img=$PF["folder"];
		else $img=$PF["folder_new"];
		// Cherche la couleur de la ligne
		if($row["deleted"]) echo "<TR bgcolor=" . $PF["del_mess_bg_color"] . " id=\"row_$count\" $highlight>";
		else echo "<TR bgcolor=$color id=\"row_$count\" $highlight>";
	
		echo "<TD class=atk_forum width=4% align=center background='$bg_img'>";
			echo "<INPUT type=checkbox value='" . $row["id"] . "' name='select[]'>";
		echo "</TD>";
		echo "<TD class=atk_forum width=5% align=center background='$bg_img'>";
			echo "<IMG src='$img'>";
		echo "</TD>";
		echo "<TD class=atk_forum background='$bg_img'>";
			if($row["deleted"]) echo "<STRIKE>";
			$row["title"]=cut_text($row["title"],120);
			$row["title"]=before_print_title($row["title"]);
			echo "<A class=atk_post_tab href='" . $MYSELF . "choix=11&read=" . $row["id"] . "'>";
				echo $row["title"];
			echo "</A>";
			if($row["deleted"]) echo "</STRIKE>";
		echo "</TD>";
		echo "<TD class=atk_forum align=center width=18% background='$bg_img'>";
			
			if(!empty($CONNECTED_FORUM_USER[$row["sender"]])) echo "<IMG src='images/eclair_jaune.gif' align=center ALT='" . $LANG["FORUM-CONNECTED-FORUM"] . "' TITLE='" . $LANG["FORUM-CONNECTED-FORUM"] . "'>&nbsp;";
			elseif(!empty($CONNECTED_INDEX_USER[$row["sender"]])) echo "<IMG src='images/eclair_vert.gif' align=center ALT='" . $LANG["FORUM-CONNECTED-INDEX"] . "' TITLE='" . $LANG["FORUM-CONNECTED-INDEX"] . "'>&nbsp;";

			if($row["deleted"]) echo "<STRIKE>";
			echo "<a class=atk_post_tab href='" . $MYSELF . "choix=5&method=3&login=" . $row["sender"] . "'>";
			echo $row["sender"];
			echo "</A>";
			if($row["deleted"]) echo "</STRIKE>";
		echo "</TD>";
		echo "<TD class=atk_forum align=center width=17% background='$bg_img'>";
			if($row["deleted"]) echo "<STRIKE>";
			$row["date"]=date($LANG["FORMAT-DATE"],$row["date"]);
			echo $row["date"];
			if($row["deleted"]) echo "</STRIKE>";
		echo "</TD>";
		echo "</TR>";
	}

	// Fin du formulaire
	echo "</form>";

	// Il n'y a pas de message dans la messagerie
	if(empty($flag)){
		echo "<TR bgcolor=" . $PF["bg_line_1"] . "><TD class=atk_body_img colspan=5>";
			echo "<p class=atk_post_tab align=center><BR><BR>" . $LANG["NO-MSG"];
			echo "<BR><BR><BR>";
		echo "</TD></TR>";
	}

	// On affiche la barre de menu de la messagerie
	echo "<TR><TD class=atk_ssmenu colspan=5>";

		echo "&nbsp;&nbsp;&nbsp;<IMG src='./images/upright.gif' align=center>&nbsp;&nbsp;&nbsp;&nbsp;";
		if(!empty($flag)){
			echo "<A class=atk_post_tab href='javascript:document.form.submit()'>" . $LANG["INBOX-DELETE"] . "</A>";
			echo "&nbsp;&nbsp;-&nbsp;&nbsp;";		
		}
		if(!empty($flag)){
			echo "<A class=atk_post_tab href='" . $MYSELF . "choix=11&action=inbox_purge'>" . $LANG["INBOX-PURGE"] . "</A>";
			echo "&nbsp;&nbsp;-&nbsp;&nbsp;";
		}
		echo "<A class=atk_post_tab href='" . $MYSELF . "choix=11&option=write'>" . $LANG["INBOX-MENU-1"] . "</A>";
		echo "&nbsp;&nbsp;-&nbsp;&nbsp;";
		echo "<A class=atk_post_tab href='" . $MYSELF . "choix=11&option=send'>" . $LANG["INBOX-MENU-SEND"] . "</A>";

	echo "</TD></TR>";

	echo "</TABLE>";
}

/*****************************/
/* crit le message n $read */
/*****************************/
function print_msg($read){
	global $MYSELF, $LANG, $ATK_LOGIN, $PF, $OPACITY, $DATE, $PRESENCE, $CONNECTED_FORUM_USER, $CONNECTED_INDEX_USER;

	echo "<BR>";

	// On recherche les infos sur le message
	$query="
		SELECT atk_inbox.*, atk_users.*
		FROM atk_inbox, atk_users
		WHERE (recipient='$ATK_LOGIN' OR sender = '$ATK_LOGIN')		
		AND atk_inbox.sender = atk_users.login
		AND atk_inbox.id=$read";
	$sql=dbquery($query);
	if(!$row=mysql_fetch_array($sql)) return 0;

	// On marque le message comme lu si le lecteur est le destinataire
	if(strtolower($ATK_LOGIN) == strtolower($row["recipient"])){
		$query="UPDATE atk_inbox SET seen=1 WHERE id=$read";
		$sql=dbquery($query);
	}

	$row["title"]=before_print_title($row["title"]);
	$row["text"]=before_print_text($row["text"]);
	$row["signature"]=before_print_text($row["signature"]);

	echo "<table class=atk_default width=100% cellspacing=0px><tr>";
		echo "<td class=atk_title align=center>";
			echo $row["title"];
		echo "</td>";
	echo "</tr><tr>";
		echo "<td class=atk_body_img>";	

			// Prpare la mise en place du fade
			$fade = " onmouseover=nereidFade(this,100,30,10) ";
			$fade.= "style='FILTER: alpha(opacity=$OPACITY)' ";
			$fade.= "onmouseout=nereidFade(this,$OPACITY,50,5)";
				
			echo "<table width=100% cellpadding=0px cellspacing=0px><tr>";
			echo "<td width=140px class=atk_body valign=top>";

				echo "<BR>";
				echo "<TABLE width=100% cellpadding=0 cellspacing=0>";
				echo "<TR>";
				echo "<TD class=atk_body valign=top>";
			
				if(!empty($CONNECTED_FORUM_USER[$row["sender"]])) echo "<IMG src='images/eclair_jaune.gif' align=center ALT='" . $LANG["FORUM-CONNECTED-FORUM"] . "' TITLE='" . $LANG["FORUM-CONNECTED-FORUM"] . "'>&nbsp;";
				elseif(!empty($CONNECTED_INDEX_USER[$row["sender"]])) echo "<IMG src='images/eclair_vert.gif' align=center ALT='" . $LANG["FORUM-CONNECTED-INDEX"] . "' TITLE='" . $LANG["FORUM-CONNECTED-INDEX"] . "'>&nbsp;";

				if($row["show_email"]){
					echo "<a href='mailto:" . $row["email"] . "' ALT='" . $row["email"] . "' TITLE='" . $row["email"] . "'>";
					echo $row["sender"];
					echo "</a>";
				} elseif($row["sender"]=="nobody") echo $LANG["NOBODY"];
				else echo $row["sender"];
				echo"<BR><BR>";	

				if($row["sender"] != "nobody"){
					echo "<a href='" . $MYSELF . "choix=5&method=3&login=" . $row["sender"] . "'>";
					echo "<img src='./images/profil.gif' ALT='" . $LANG["POST-PROFIL"] . "' TITLE='" . $LANG["POST-PROFIL"] . "' border='0px'";
					if($PF["fade_icon"]) echo $fade;
					echo "></a>";
				}
				if($row["url"]){
					echo "&nbsp;&nbsp;";
					echo "<a href='" . $row["url"] . "' target='_blank'>";
					echo "<img src='./images/web.gif' border='0px' ALT='" . $LANG["POST-WEB"] . " : " . $row["url"] . "' TITLE='" . $LANG["POST-WEB"] . " : " . $row["url"] . "'";
					if($PF["fade_icon"]) echo $fade;
					echo "></a>";
				}
				$icon=strrev(decbin($PF["icon"]));
				if(!empty($icon[0]) && $row["sender"] != "nobody"){
					echo "&nbsp;&nbsp;";
					echo "<a href='" . $MYSELF . "choix=11&recipient=" . $row["sender"] . "&option=write'>";
					echo "<img src='./images/empty.gif' ALT='" . $LANG["POST-MP"] . "' TITLE='" . $LANG["POST-MP"] . "' border='0px'";
					if($PF["fade_icon"]) echo $fade;
					echo "></a>";
				}
				if($row["sender"] != "nobody" AND $row["msn"]){
					echo "&nbsp;&nbsp;";
					echo "<a href='" . $MYSELF . "choix=5&method=3&login=" . $row["sender"] . "'>";
					echo "<img src='./images/msn.gif' ALT='" . $LANG["POST-MSN"] . " : " . $row["msn"] . "' TITLE='" . $LANG["POST-MSN"] . " : " . $row["msn"] . "' border='0px'";
					if($PF["fade_icon"]) echo $fade;
					echo "></a>";
				}
				if($row["sender"] != "nobody" AND $row["icq"]){
					echo "&nbsp;&nbsp;";
					echo "<a href='" . $MYSELF . "choix=5&method=3&login=" . $row["sender"] . "'>";
					echo "<IMG src='./images/icq.gif' ALT='" . $LANG["POST-ICQ"] . " : " . $row["icq"] . "' TITLE='" . $LANG["POST-ICQ"] . " : " . $row["icq"] . "' border='0px'";
					if($PF["fade_icon"]) echo $fade;
					echo "></a>";
				}
				if($row["sender"] != "nobody" AND $row["aim"]){
					echo "&nbsp;&nbsp;";
					echo "<a href='" . $MYSELF . "choix=5&method=3&login=" . $row["sender"] . "'>";
					echo "<img src='./images/aim.gif' ALT='" . $LANG["POST-AIM"] . " : " . $row["aim"] . "' TITLE='" . $LANG["POST-AIM"] . " : " . $row["aim"] . "' border='0px'";
					if($PF["fade_icon"]) echo $fade;
					echo "></a>";
				}
				if($row["sender"] != "nobody" AND $row["skype"]){
					echo "&nbsp;&nbsp;";
					echo "<a href='" . $MYSELF . "choix=5&method=3&login=" . $row["sender"] . "'>";
					echo "<img src='./images/skype.gif' ALT='" . $LANG["POST-SKYPE"] . " : " . $row["skype"] . "' TITLE='" . $LANG["POST-SKYPE"] . " : " . $row["skype"] . "' border='0px'";
					if($PF["fade_icon"]) echo $fade;
					echo "></a>";
				}
				if($row["sender"] != "nobody" AND $row["yahoo"]){
					echo "&nbsp;&nbsp;";
					echo "<a href='" . $MYSELF . "choix=5&method=3&login=" . $row["sender"] . "'>";
					echo "<img src='./images/yahoo.gif' ALT='" . $LANG["POST-YAHOO"] . " : " . $row["yahoo"] . "' TITLE='" . $LANG["POST-YAHOO"] . " : " . $row["yahoo"] . "' border='0px'";
					if($PF["fade_icon"]) echo $fade;
					echo "></a>";
				}
				
				echo "<BR><BR>";
				
				// Affichage de l'avatar
				if($PF["avatar"] && $row["avatar"]){
					echo "<center><img src='" . $row["avatar"] . "' alt='" . $row["sender"] . "' title='" . $row["sender"] . "' ";
					echo "width='" . $row["size_0"] . "' height='" . $row["size_1"] . "'></center><BR>";
				}


				if($row["show_status"]==0){
					if($row["sender"] != "nobody"){
						$q=$row["nb_post"]/(($DATE-$row["subscribe"])/86400);
						$part=10;
						if($q<$PRESENCE[9]) $part=9;
						if($q<$PRESENCE[8]) $part=8;
						if($q<$PRESENCE[7]) $part=7;
						if($q<$PRESENCE[6]) $part=6;
						if($q<$PRESENCE[5]) $part=5;
						if($q<$PRESENCE[4]) $part=4;
						if($q<$PRESENCE[3]) $part=3;
						if($q<$PRESENCE[2]) $part=2;
						if($q<$PRESENCE[1]) $part=1;
						$img = "images/stars/stars-$part.gif";
						$rowext = ($part/2) . " / 5";					
						echo "<b>Activit :</b> <IMG src='$img' ALT='$rowext' TITLE='$rowext'><BR>";
					
						if(!empty($PF["max_status"]) && !empty($PF["status"])){
							$status = status($row["nb_post"]);
							echo "$status<BR><BR>";
						}
					
					}
				}

				echo "</TD>";
				echo "</TR>";
				echo "</TABLE>";

			echo "</TD>";
			echo "<td valign=top class=atk_body>";
		
				echo "<BR><TABLE width=100% cellpadding=0 cellspacing=0>";
				echo "<TR>";			
					$date=date($LANG["FORMAT-DATE"],$row["date"]+($PF["local_time"]*3600));
					echo "<td class=atk_body valign=top><b>" . $LANG["POST-DATE"];
					echo " :</b>&nbsp;&nbsp;$date";
				echo "</td>";
				echo "<TD align=right width=280px>";
					
					if($row["sender"] != "$ATK_LOGIN"){
					
						$size = getimagesize($PF["button"]);
					
						echo "<TABLE background='" . $PF["button"] . "' border=0 cellpadding=0 cellspacing=0 width='" . $size[0] . "' height='" . $size[1] . "'><TR><TD align='center'>";
							echo "<A class=atk_button_link href='" . $MYSELF . "choix=11&read=" . $row["id"] . "&recipient=" . $row["sender"] . "&option=write' ALT='" . $LANG["POST-ANSWER"] . "' TITLE='" . $LANG["POST-ANSWER"] . "'>";
								echo $LANG["ANSWER-ICON"];
							echo "</A>";
						echo "</TD></TR></TABLE>";

					}
					
				echo "</TD>";
				echo "</tr>";
				echo "<tr>";
					echo "<td class=atk_body colspan=2><BR>" . $row["text"] . "<BR><BR></td>";
				echo "</tr><tr>";
					echo "<td class=atk_body colspan=2 align=right>";
						if(!empty($row["signature"])){
							echo "--------------------------------<BR>";
							echo $row["signature"];
						}
					echo "</td>";
				echo "</tr></table>";
					
				echo "</td>";
			echo "</tr></table>";

			echo "</td>";
		echo "</tr></table>";

}

/*********************************************************/
/* Affiche le formulaire pour envoyer un nouveau message */
/*********************************************************/
function print_write($recipient, $title, $text){
	global $PF, $LANG, $MYSELF, $MYSELF, $ATK_LOGIN, $NB_COLS;

	echo "<BR>";

	echo "<table class=atk_default width=100% cellspacing=0px><tr>";
	echo "<td class=atk_title align=center>" . $LANG["INBOX-WRITE-TITLE"] . "</td>";
	echo "</tr><tr>";
		echo "<td class=atk_body_img align=center>";

			echo "<form name=send method='post' action='" . $MYSELF . "choix=11&action=inbox_send'>";

			echo "<br><table border=0 align=center>";
			echo "<tr><td class=atk_body valign=top align=right width=160px>";
				echo "<b>" . $LANG["INBOX-RECIPIENT"] . " :</b>";
			echo "</td><td class=atk_body align=left>";
				echo "<input class=atk_input type=text name='recipient' size=26 value='$recipient'>";
				echo "<i>" . $LANG["INBOX-RECIPIENT-MULTIPLE"] . "</i>";
			echo "</td></tr>";

			echo "<tr><td class=atk_body valign=top align=right width=160px>";
				echo "<b>" . $LANG["INBOX-MSG-TITLE"] . " :</b>";
			echo "</td><td class=atk_body align=left>";
				echo "<input class=atk_input type=text name='title' size=40 value=\"$title\" onfocus='new_focus(1)' onclick='storeCaret(this)' onkeyup='storeCaret(this)'>";
			echo "</td></tr>";

			echo "<tr><td class=atk_body valign=top align=right width=160px>";
				echo "<b>" . $LANG["INBOX-MSG-TEXT"] . " :</b><br>";
				show_options();
			echo "</td><td class=atk_body align=left>";
				echo "<textarea class=atk_input rows='10' name='text' cols='$NB_COLS' onfocus='new_focus(0)' onclick='storeCaret(this)' onkeyup='storeCaret(this)'>";
				echo $text;
				echo "</textarea>";

				// Script pour la prvisualisation + affichage du lien
				echo "<SCRIPT LANGUAGE=JavaScript>";
					echo "function prev(){";
						echo "var url = '" . $MYSELF . "action=prev';";
						echo "var title=document.send.title.value;";
						echo "var text=document.send.text.value;";

						if($ATK_LOGIN=="nobody"){
							echo "var login=document.send.login.value;";
							echo "login=login.replace(/\+/g,'[plus]');";
							echo "login=login.replace(/&/g,'[and]');";
							echo "login=login.replace(/#/g,'[diese]');";
							echo "url = url + \"&login=\" + login;";
						}

						echo "title=title.replace(/\+/g,'[plus]');";
						echo "title=title.replace(/&/g,'[and]');";
						echo "title=title.replace(/#/g,'[diese]');";
						echo "text=text.replace(/\+/g,'[plus]');";
						echo "text=text.replace(/&/g,'[and]');";
						echo "text=text.replace(/#/g,'[diese]');";
						echo "text=text.replace(/\\n/g,'[nl]');";

						echo "url = url + \"&title=\" + title;";
						echo "url = url + \"&text=\" + text;";
						echo "window.open(url,'','width=790px,height=300,left=5,top=5,menubar=yes,scrollbars=yes,resizable=yes');";
					echo "}";
				echo "</SCRIPT>";

				echo "<br>&nbsp;&nbsp;&nbsp;";
				echo "<a href='JavaScript:prev()'>" . $LANG["FORM-PREV"] . "</a>";

			echo "</td></tr>";
			echo "</table>";

			include("javascript/TagProcess.js");

			?>
			<SCRIPT language="JavaScript">
				focus_box=document.send.text;
				focus_box.focus();
			</SCRIPT>
			<?

			// Affiche le tableau des smileys si il y en a
			show_smileys();

			echo "<BR>";
			echo "<CENTER>";		
			$size = getimagesize($PF["button"]);
			echo "<TABLE background='" . $PF["button"] . "' border=0 cellpadding=0 cellspacing=0 width='" . $size[0] . "' height='" . $size[1] . "'><TR><TD align='center'>";
				echo "<A class=atk_button_link href='javascript:document.send.submit()' TITLE='" . $LANG["POST-ANSWER"] . "'>";
					echo $LANG["INPUT-OK"];
				echo "</A>";
			echo "</TD></TR></TABLE>";
			echo "<BR></CENTER>";

			echo "</form>";

		echo "</td>";
	echo "</tr></table>";
}

/*****************************************/
/* Affiche la liste des messages envoys */
/*****************************************/
function print_send(){
	global $LANG, $ATK_LOGIN, $MYSELF, $PF, $CONNECTED_FORUM_USER, $CONNECTED_INDEX_USER;

	// On rcupre tous les messages
	$query="
		SELECT atk_inbox.*, atk_users.email, atk_users.show_email
		FROM atk_inbox, atk_users
		WHERE atk_inbox.sender='$ATK_LOGIN'
		AND atk_inbox.sender = atk_users.login
		AND atk_inbox.deleted_done <> 2
		ORDER BY date DESC";
	$sql=dbquery($query);

	// Affichage del'entte de la messagerie
	echo "<BR><TABLE class=atk_default width=100% cellspacing=0 cellpadding=0>";
	echo "<TR><TD class=atk_title colspan=5>";

		// Affichage de l'entete de la rubrique courante
		echo "<TABLE width=100% cellspacing=0 cellpadding=0><TR>";
		echo "<TD class=atk_menu width=36px align=left>";
			echo "<INPUT type=checkbox name='noname' onclick='CheckboxControl()'>";
		echo "</TD>";
		echo "<TD class=atk_menu width=36px align=center>";
		echo "</TD>";		
		echo "<TD align=center>";
			echo "<p class=atk_menu><b>" . $LANG["INBOX-COL-2-SEND"] . "</b>";
		echo "</TD>";
		echo "<TD class=atk_body width=130px align=center>";
			echo "<p class=atk_menu><b>" . $LANG["INBOX-COL-3-SEND"] . "</b>";
		echo "</TD>";
		echo "<TD class=atk_body width=110px align=center>";
          	echo "<p class=atk_menu><b>" . $LANG["INBOX-COL-4-SEND"] . "</b>";
		echo "</TD>";
		echo "</TR></TABLE>";

	echo "</TD></TR>";
	
	// Gestion des CheckBox en javascript
	echo "<SCRIPT language='JavaScript' src='javascript/CheckBox.js' type='text/javascript'></SCRIPT>";

	// Gestion de la surbrillance
	if($PF["bg_highlight"] || $PF["bg_onclick"]){
		include("./javascript/highlight.js");
		$highlight = "onClick=\"setRowColor(this, '" . $PF["bg_onclick"] . "', 'click')\" onMouseOver=\"setRowColor(this, '" . $PF["bg_highlight"] . "', 'over')\" onMouseOut=\"setRowColor(this, '', 'out')\"";
	} else $highlight="";
	$count=0;
	
	echo "<form name=form method='post' action='" . $MYSELF . "choix=11&action=inbox_del&option=send'>";

	$color=""; $bg_img="";
	while($row=mysql_fetch_array($sql)){
		$count++;
	
	     if(!isset($flag)) $flag=1;
	     
	     if($row["deleted"] == 2 || $row["deleted"] == 3) $row["deleted"] = 1;
	     else $row["deleted"] = 0;

		/******************************************/
		/* Affichage d'un message dans le tableau */
		/******************************************/
		// Alternance des couleurs
		if($color==$PF["bg_line_1"]) $color=$PF["bg_line_2"]; else $color=$PF["bg_line_1"];
		if($bg_img==$PF["img_line_1"]) $bg_img=$PF["img_line_2"]; else $bg_img=$PF["img_line_1"];
		// Recherche l'image du dossier
		if($row["seen"]) $img=$PF["folder"];
		else $img=$PF["folder_new"];
		// Cherche la couleur de la ligne
		if($row["deleted"]) echo "<TR bgcolor=" . $PF["del_mess_bg_color"] . " id=\"row_$count\" $highlight>";
		else echo "<TR bgcolor=$color id=\"row_$count\" $highlight>";
		
		echo "<TD class=atk_forum width=4% align=center background='$bg_img'>";
			echo "<INPUT type=checkbox value='" . $row["id"] . "' name='select[]'>";
		echo "</TD>";
	
		echo "<TD class=atk_forum width=5% align=center background='$bg_img'>";
			echo "<IMG src='$img'>";
		echo "</TD>";
		echo "<TD class=atk_forum background='$bg_img'>";
			if($row["deleted"]) echo "<STRIKE>";
			$row["title"]=cut_text($row["title"],120);
			$row["title"]=before_print_title($row["title"]);
			echo "<A class=atk_post_tab href='" . $MYSELF . "choix=11&option=send&read=" . $row["id"] . "'>";
				echo $row["title"];
			echo "</A>";
			if($row["deleted"]) echo "</STRIKE>";
		echo "</TD>";
		echo "<TD class=atk_forum align=center width=18% background='$bg_img'>";
			
			if(!empty($CONNECTED_FORUM_USER[$row["recipient"]])) echo "<IMG src='images/eclair_jaune.gif' align=center ALT='" . $LANG["FORUM-CONNECTED-FORUM"] . "' TITLE='" . $LANG["FORUM-CONNECTED-FORUM"] . "'>&nbsp;";
			elseif(!empty($CONNECTED_INDEX_USER[$row["recipient"]])) echo "<IMG src='images/eclair_vert.gif' align=center ALT='" . $LANG["FORUM-CONNECTED-INDEX"] . "' TITLE='" . $LANG["FORUM-CONNECTED-INDEX"] . "'>&nbsp;";

			if($row["deleted"]) echo "<STRIKE>";
			echo "<a class=atk_post_tab href='" . $MYSELF . "choix=5&method=3&login=" . $row["recipient"] . "'>";
			echo $row["recipient"];
			echo "</A>";
			if($row["deleted"]) echo "</STRIKE>";
		echo "</TD>";
		echo "<TD class=atk_forum align=center width=17% background='$bg_img'>";
			if($row["deleted"]) echo "<STRIKE>";
			$row["date"]=date($LANG["FORMAT-DATE"],$row["date"]);
			echo $row["date"];
			if($row["deleted"]) echo "</STRIKE>";
		echo "</TD>";
		echo "</TR>";
	}

	// Il n'y a pas de message dans la messagerie
	if(empty($flag)){
		echo "<TR bgcolor=" . $PF["bg_line_1"] . "><TD class=atk_body_img colspan=5>";
			echo "<p class=atk_post_tab align=center><BR><BR>" . $LANG["NO-MSG"];
			echo "<BR><BR><BR>";
		echo "</TD></TR>";
	}

	// On affiche la barre de menu de la messagerie
	echo "<TR><TD class=atk_ssmenu colspan=5>";

		echo "&nbsp;&nbsp;&nbsp;<IMG src='./images/upright.gif' align=center>&nbsp;&nbsp;&nbsp;&nbsp;";
		if(!empty($flag)){
			echo "<A class=atk_post_tab href='javascript:document.form.submit()'>" . $LANG["INBOX-DELETE"] . "</A>";
			echo "&nbsp;&nbsp;-&nbsp;&nbsp;";		
		}
		if(!empty($flag)){
			echo "<A class=atk_post_tab href='" . $MYSELF . "choix=11&action=inbox_purge&option=send'>" . $LANG["INBOX-PURGE"] . "</A>";
			echo "&nbsp;&nbsp;-&nbsp;&nbsp;";
		}
		echo "<A class=atk_post_tab href='" . $MYSELF . "choix=11&option=write'>" . $LANG["INBOX-MENU-1"] . "</A>";
		echo "&nbsp;&nbsp;-&nbsp;&nbsp;";
		echo "<A class=atk_post_tab href='" . $MYSELF . "choix=11'>" . $LANG["INBOX-MENU-RETURN-SEND"] . "</A>";

	echo "</TD></TR>";
	
	echo "</form>";

	echo "</TABLE>";
}
?>
