/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

var red=0;
var green=0;
var blue=0;

function DEC_HEXA(dec)
{
     var hexa='0123456789ABCDEF',hex=''
     while (dec>15)
     {
          tmp=dec-(Math.floor(dec/16))*16;
          hex=hexa.charAt(tmp)+hex;
          dec=Math.floor(dec/16);
     }
     hex=hexa.charAt(dec)+hex;
     if(hex.length < 2) hex = '0' + hex;
     return(hex);
} 

function load_rgb(id){
	var hex = document.getElementById(id).value;

	if(hex.length!=7)
	{
		red=0;
		green=0;
		blue=0;
	}
	else
	{
		red=parseInt(hex.substr(1,2),16);
		green=parseInt(hex.substr(3,2),16);
		blue=parseInt(hex.substr(5,2),16);
	}
}

function more_red(id)
{
	load_rgb(id);
	red=red+16;
	if(red>255) red=255;
	apply(id);
}

function less_red(id)
{
	load_rgb(id);
	red=red-16;
	if(red<0) red=0;
	apply(id);
}

function more_green(id)
{
	load_rgb(id);
	green=green+16;
	if(green>255) green=255;
	apply(id);
}

function less_green(id)
{
	load_rgb(id);
	green=green-16;
	if(green<0) green=0;
	apply(id);
}

function more_blue(id)
{
	load_rgb(id);
	blue=blue+16;
	if(blue>255) blue=255;
	apply(id);
}

function less_blue(id)
{
	load_rgb(id);
	blue=blue-16;
	if(blue<0) blue=0;
	apply(id);
}

function apply(id)
{
	var hex = '#' + DEC_HEXA(red) + DEC_HEXA(green) + DEC_HEXA(blue);
	document.getElementById(id).value=hex;
	document.getElementById("tab" + id).style.background = hex;
}

function refresh(id)
{
	load_rgb(id);
	var hex = '#' + DEC_HEXA(red) + DEC_HEXA(green) + DEC_HEXA(blue);
	document.getElementById("tab" + id).style.background = hex;
}
