<?
/*****************************************************************************/
/* Aztek Forum - PHP/Mysql forum                                             */
/* Copyright (C) 2003, 2004 Le Guilcher Yannick                              */
/*                                                                           */
/* This file is part of Aztek Forum.                                         */
/*                                                                           */
/* Aztek Forum is free software; you can redistribute it and/or modify       */
/* it under the terms of the GNU General Public License as published by      */
/* the Free Software Foundation; either version 2 of the License, or         */
/* (at your option) any later version.                                       */
/*                                                                           */
/* Aztek Forum is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of            */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             */
/* GNU General Public License for more details.                              */
/*                                                                           */
/* You should have received a copy of the GNU General Public License         */
/* along with Aztek Forum; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */
/*                                                                           */
/* Contact: webmaster@forum-aztek.com                                        */
/* Website: http://www.forum-aztek.com                                       */
/*****************************************************************************/

/*********************/
/* Fonction centrale */
/*********************/
function search($search, $forum_choice, $owner, $page){

	// Initialise la page si besoin
	if(empty($page)) $page=1;
	// Supprime le HTML et Javascript
	$search=str_replace("<","&lt;",$search);
	
	// Affiche le formulaire de la recherche
	search_form($search, $forum_choice, $owner);
	// Affiche les rsultats de la recherche
	if($search) search_result($search, $owner, $forum_choice, $page);

}

/**************************************/
/* Affiche le formulaire de recherche */
/**************************************/
function search_form($search, $forum_choice, $owner){
	global $PF, $MYSELF, $LANG, $ASSIGN_SEARCH, $FORUM;

	// Vrifie si la recherche se fait d'un forum prive
	// ce qui entrainerait une recherche rduite  ce forum
	if(!empty($PF["passwd"])) $forum=$FORUM;
	else $forum=0;

	if(empty($forum_choice)) $forum_choice = 0;

	// Prpare l'affiche du choix des forums (SELECT)
	if(!$forum){

		switch($ASSIGN_SEARCH){

			// Tous les forums
			case 0:
				$query = "
					SELECT id,title
					FROM atk_forums
					WHERE atk_forums.passwd = ''
					ORDER BY title ASC";
				$sql = dbquery($query);
				if(!$forum_choice) $selected="SELECTED"; else $selected="";
				$option = "<OPTION value='0' $selected>" . $LANG["SEARCH-IN-ALL-FORUM"] . "</OPTION>";
				while($row=mysql_fetch_array($sql)){
					if($row["id"] == $forum_choice) $selected="SELECTED"; else $selected="";
					$option .= "<OPTION value='" . $row["id"] . "' $selected>" . cut_text($row["title"],30) . "</OPTION>";
				}
				break;

			// Tous les forums du mme $owner
			case 1:
				$query = "
					SELECT id,title
					FROM atk_forums
					WHERE atk_forums.passwd = ''
					AND atk_forums.owner='$owner'
					ORDER BY title ASC";
				$sql = dbquery($query);
				if(!$forum_choice) $selected="SELECTED"; else $selected="";
				$option = "<OPTION value='0' $selected>" . $LANG["SEARCH-IN-ALL-FORUM"] . "</OPTION>";
				while($row=mysql_fetch_array($sql)){
					if($row["id"] == $forum_choice) $selected="SELECTED"; else $selected="";
					$option .= "<OPTION value='" . $row["id"] . "' $selected>" . cut_text($row["title"],30) . "</OPTION>";
				}
				break;

			// Uniquement le forum concern ou tous les forums si de l'index
			case 2:
				if(!empty($FORUM)) $forum=$FORUM;
				else $forum=0;
				break;

		}
	}

	// Saut de ligne
	echo "<BR>";
	
	// Dbut du tableau
	echo "<table class=atk_default width=100% cellspacing=0px><tr>";
		echo "<td class=atk_title align=center>";
			echo $LANG["SEARCH-TITLE"];
		echo "</td>";
	echo "</tr><tr>";
		echo "<td class=atk_body_img height=70px>";

			echo "<br><table width=100% cellpadding=0px cellspacing=0px><tr>";
			echo "<td class=atk_body align=center>";

               	echo "<form name=search method='post' action='" . $MYSELF . "choix=10'>";

				echo "<TABLE><TR><TD>";
				
					echo "<TABLE align=center><TR><TD class=atk_body>";
						echo "<b>" . $LANG["SEARCH-WORDS"] . ":</b> ";
					echo "</TD><TD>";
						$search=stripslashes($search);
						$search=str_replace("\"","'",$search);
						echo "<INPUT class=atk_input type=text name=search value=\"$search\" size=30>";
					echo "</TD></TR>";
					// Si un forum est dj choisi, on ne donne pas le choix du forum
					if($forum){
						echo "<INPUT type=hidden name='forum_choice' value='$forum'>";
					} else {
						echo "<TR><TD class=atk_body>";
							echo "<b>" . $LANG["SEARCH-FORUM-CHOICE"] . ":</b>";
						echo "</TD><TD>";
						echo "<SELECT class=atk_input name='forum_choice'>";
						echo $option;
						echo "</SELECT>&nbsp;&nbsp;&nbsp;";
						echo "</TD></TR>";
					}
					echo "</TABLE>";
				
				echo "</TD><TD>";
				
					echo "<BR>";
					echo "<CENTER>";		
					$size = getimagesize($PF["button"]);
					echo "<TABLE background='" . $PF["button"] . "' border=0 cellpadding=0 cellspacing=0 width='" . $size[0] . "' height='" . $size[1] . "'><TR><TD align='center'>";
						echo "<A class=atk_button_link href='javascript:document.search.submit()' TITLE='" . $LANG["POST-ANSWER"] . "'>";
							echo $LANG["INPUT-OK"];
						echo "</A>";
					echo "</TD></TR></TABLE>";
					echo "<BR></CENTER>";

				echo "</TD></TR></TABLE><BR>";
				
				echo "</form>";

				// Si aucune recherche affiche un exemple
				if(!$search){
					echo $LANG["SEARCH-OPTIONS"];
					echo "<br><br><br>";
				}

			echo "</tr></table>";

		echo "</td>";
	echo "</tr></table>";

}

/*******************************************/
/* Effectue les requtes pour la recherche */
/*******************************************/
function search_result($search, $owner, $forum_choice, $page){
	global $ASSIGN_SEARCH, $LANG, $FORUM;

	// Calcule la page des rsultats de la recherche
	$debut = ($page-1)*20;

	$mysql_version = dbgetfirst("SELECT version();");
	if($mysql_version >= "4.0.1") $in_boolean_mode =  "IN BOOLEAN MODE";
	else $in_boolean_mode=""; 
	
	if($forum_choice){

		// On vrifie que l'on a bien le droit de rechercher
		// dans le forum choisi
		$auto=0;
		switch($ASSIGN_SEARCH){
			case 0:
				// Si on recherche dans le forum courant, pas de problme
				if(!empty($FORUM) AND $forum_choice==$FORUM) $auto=1;
				else {
					// Si on est dans un forum, vrifie qu'il n'est pas priv
					$query = "SELECT passwd FROM atk_forums WHERE id=$forum_choice";
					$passwd=dbgetfirst($query);
					// Si le forum choisi n'est pas priv, pas de problme
					if(!$passwd) $auto=1;
				}
				break;

			case 1:
			case 2:
				// Si on recherche dans le forum courant, pas de problme
				if(!empty($FORUM) AND $forum_choice==$FORUM) $auto=1;
				else {
					// Si on est dans un forum, vrifie qu'il n'est pas priv
					$query = "SELECT passwd FROM atk_forums WHERE id=$forum_choice AND owner='$owner'";
					$passwd=dbgetfirst($query);
					// Si le forum choisi n'est pas priv, pas de problme
					if(!$passwd) $auto=1;
				}
				break;
		}

		// effectue la recherche
		if($auto){
			$query = "
				SELECT MATCH (atk_posts.title,atk_posts.text) AGAINST (\"$search\" $in_boolean_mode),
				atk_forums.id AS FORUMID, atk_forums.filename, atk_forums.title AS FORUMTITLE,
				atk_posts.id, atk_posts.title, atk_posts.text,
				atk_posts.sender, atk_posts.date, atk_posts.visited
				FROM atk_forums, atk_posts
				WHERE MATCH (atk_posts.title,atk_posts.text)
				AGAINST (\"$search\" $in_boolean_mode)
				AND atk_posts.forum = $forum_choice
				AND atk_forums.id = atk_posts.forum
				LIMIT $debut,21";
			$sql = dbquery($query);
		}

	} else {

		if(!$ASSIGN_SEARCH){
			// On fait la recherche pour tous les forums public
			$query = "
				SELECT MATCH (atk_posts.title,atk_posts.text) AGAINST (\"$search\" $in_boolean_mode),
				atk_forums.id AS FORUMID, atk_forums.filename, atk_forums.title AS FORUMTITLE,
				atk_posts.id, atk_posts.title,atk_posts.text,
				atk_posts.sender, atk_posts.date, atk_posts.visited
				FROM atk_forums, atk_posts
				WHERE MATCH (atk_posts.title,atk_posts.text)
				AGAINST (\"$search\" $in_boolean_mode)
				AND atk_forums.id = atk_posts.forum
				AND atk_forums.passwd = ''
				LIMIT $debut,21";
		} else {
			// On fait la recherche pour tous les forums public de $owner
			$query = "
				SELECT MATCH (atk_posts.title,atk_posts.text) AGAINST (\"$search\" $in_boolean_mode),
				atk_forums.id AS FORUMID, atk_forums.filename, atk_forums.title AS FORUMTITLE,
				atk_posts.id, atk_posts.title, atk_posts.text,
				atk_posts.sender, atk_posts.date, atk_posts.visited
				FROM atk_forums, atk_posts
				WHERE MATCH (atk_posts.title,atk_posts.text)
				AGAINST (\"$search\" $in_boolean_mode)
				AND atk_forums.id = atk_posts.forum
				AND atk_forums.passwd = ''
				AND atk_forums.owner = '$owner'
				LIMIT $debut,21";
		}
		
		$sql = dbquery($query);
		
	}

	if(!empty($sql)) show_result($sql, $search, $forum_choice, $page);

}

/*************************/
/* Affiche les rsultats */
/*************************/
function show_result($sql, $search, $forum_choice, $page){
	global $LANG, $BY_ID, $MYSELF;

	// Affiche un saut de ligne
	echo "<BR>";
	
	echo "<table class=atk_default width=100% cellspacing=0px><tr>";
		echo "<td class=atk_title align=center>";
			echo $LANG["SEARCH-RESULT"];
		echo "</td>";
	echo "</tr><tr>";
		echo "<td class=atk_body_img height=70px><br>";

			echo "<center><table width='96%'><tr><td class=atk_body>";

				$flag=0;
				while($flag<20 && $row=mysql_fetch_array($sql)){
					
					// On augmente le nombre de rsultat affich
					$flag++;

					// Traitement des textes des rsultats
					$row["text"] = cut_text($row["text"],300);
					$nb_cit_1 = substr_count($row["text"], "[cit]");
					$nb_cit_2 = substr_count($row["text"], "[/cit]");
					for($i=$nb_cit_2; $i<$nb_cit_1; $i++) $row["text"] = $row["text"] . "[/cit]";
					$row["title"]=before_print_title(cut_text($row["title"],70));
					$row["text"]=before_print_text($row["text"]);

					// Titre du message
					echo "<TABLE width=100% cellpadding=0 cellspacing=0>";
					echo "<TR>";
						echo "<TD>";
							echo "<IMG src='./images/fleche.gif'>";
					     echo "</TD>";
					     echo "<TD class=atk_body>";
					
							if(!$BY_ID) echo "<a class=atk_lien href='" . $row["filename"] . "?msg=" . $row["id"] . "#" . $row["id"] . "'>" . $row["title"] . "</a>";
							else echo "<a class=atk_lien href='forum.php?fid=" . $row["FORUMID"] . "&msg=" . $row["id"] . "#" . $row["id"] . "'>" . $row["title"] . "</a>";
							// Espaces
							echo "&nbsp;&nbsp;&nbsp;";
							// Indice de pertinence
							echo "<i>(" . $LANG["SEARCH-INDICE"] . " : " . floor(1000*$row[0])/1000 . ")</i>";
							// Auteur
							echo "<br><i>" . $LANG["SEARCH-BY"] . "&nbsp;&nbsp;";
							if($row["sender"] != "nobody")
								echo "<a class=atk_lien href='" . $MYSELF . "choix=5&method=3&login=" . $row["sender"] . "'>" . $row["sender"] . "</a>";
							else echo "<b>" . $LANG["NOBODY"] . "</b>";
			                    // Date
							$date=date($LANG["FORMAT-DATE"],$row["date"]);
							$LANG["POST-READ"] = str_replace("%n", $row["visited"], $LANG["POST-READ"]);
							echo "&nbsp;" . $LANG["SEARCH-THE"] . " " . $date . " (" . $LANG["POST-READ"] . ") >> &nbsp;";
							if(!$BY_ID) echo "<A href='" . $row["filename"] . "'>" . $row["FORUMTITLE"] . "</A>";
							else echo "<A href='forum.php?fid=" . $row["FORUMID"] . "'>" . $row["FORUMTITLE"] . "</A>";
							echo "</i><BR>";
						
						echo "</TD>";
					echo "</TR></TABLE>";
			          // Affiche l'extrait du texte du rsultat
					echo "<BR><center><table class=atk_table height='40px'><tr><td class=atk_body>";
						echo $row["text"];
					echo "</td></tr></table></center>";
			          // Saut de ligne
					echo "<br><br>";
				}

				// Affiche le texte d'aide pour la recherche
				if(empty($flag)) echo "<p align=center><b>" . $LANG["SEARCH-ERROR"] . "</b><br><br>";

			echo "</td></tr></table></center>";

			if($flag) echo "<p align=center>";
			
			// Page prcdente
			if($page > 1){
				$prev_page = $page - 1;
				echo "<A href='" . $MYSELF . "choix=10&search=$search&forum_choice=$forum_choice&page=$prev_page'>" . $LANG["PREV-PAGE"] . "</A>";
			
				echo "&nbsp;&nbsp;&nbsp;";
			}
			
			if($flag) echo $LANG["PAGE"] . " " . $page;
			
			// Page suivante
			if($flag==20 && $row=mysql_fetch_array($sql)){
				echo "&nbsp;&nbsp;&nbsp;";
				$next_page = $page + 1;
				echo "<A href='" . $MYSELF . "choix=10&search=$search&forum_choice=$forum_choice&page=$next_page'>" . $LANG["NEXT-PAGE"] . "</A>";
			}
			
			if($flag) echo "<BR><BR>";

		echo "</td>";
	echo "</tr></table>";
}
?>
